<?php

namespace App\Exports;

use App\Models\DivisionModel;
use Maatwebsite\Excel\Concerns\FromArray;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithEvents;
use Illuminate\Support\Facades\Session;
use Maatwebsite\Excel\Events\AfterSheet;
use Illuminate\Support\Facades\DB;
use App\Models\VehicleTrakingReportModel;
use App\Models\VehicleModel;

class CheckpointConsolidatedExport implements FromArray,WithHeadings,ShouldAutoSize,WithEvents
{
    protected $data;
    protected $headings;
    protected $columnWidth = [];
    protected $rowHeight = [];
    protected $mergeCells = [];
    protected $font = [];
    protected $fontSize = [];
    protected $bold = [];
    protected $background = []; 
    protected $vertical = []; 
    protected $sheetName;
    protected $borders = [];

    /**
    * @return \Illuminate\Support\Collection
    */
    public function array(): array
    {
        $aData = array();
        $aData['division_id']     = Session::has('division_id') ? Session::get('division_id') : 0;
        $aData['ward_id']         = Session::has('ward_id') ? Session::get('ward_id') : 0;
        $aData['vehicle_id']      = Session::has('vehicle_id') ? Session::get('vehicle_id') : 0;
        $aData['vehicle_type_id'] = Session::has('vehicle_type_id') ? Session::get('vehicle_type_id') : 0;
        $aData['date']            = Session::has('date') ? Session::get('date') : date('d-m-Y',strtotime('now'));
        $aData['records']      = VehicleTrakingReportModel::get_checkpoints_consolidated($aData);
        if( $aData['records']){
            foreach($aData['records'] as $key=>$aValue){ 
                $aData['excel'][] = array(
                    $aValue['vehicle_name'],
                     //first
                    (!empty($aValue['checkpoints']['first']->location)) ? $aValue['checkpoints']['first']->location : "-",
                    (!empty($aValue['checkpoints']['first']->expected_time)) ? $aValue['checkpoints']['first']->expected_time : "-",
                    (!empty($aValue['checkpoints']['first']->actual_reach_time)) ? $aValue['checkpoints']['first']->actual_reach_time : "-",
                    //second
                    (!empty($aValue['checkpoints']['second']->location)) ? $aValue['checkpoints']['second']->location : "-",
                    (!empty($aValue['checkpoints']['second']->expected_time)) ? $aValue['checkpoints']['second']->expected_time : "-",
                    (!empty($aValue['checkpoints']['second']->actual_reach_time)) ? $aValue['checkpoints']['second']->actual_reach_time : "-",
                    //third
                    (!empty($aValue['checkpoints']['third']->location)) ? $aValue['checkpoints']['third']->location : "-",
                    (!empty($aValue['checkpoints']['third']->expected_time)) ? $aValue['checkpoints']['third']->expected_time : "-",
                    (!empty($aValue['checkpoints']['third']->actual_reach_time)) ? $aValue['checkpoints']['third']->actual_reach_time : "-",
                    //four
                    (!empty($aValue['checkpoints']['fourth']->location)) ? $aValue['checkpoints']['fourth']->location : "-",
                    (!empty($aValue['checkpoints']['fourth']->expected_time)) ? $aValue['checkpoints']['fourth']->expected_time : "-",
                    (!empty($aValue['checkpoints']['fourth']->actual_reach_time)) ? $aValue['checkpoints']['fourth']->actual_reach_time : "-",
                     //fifth
                    (!empty($aValue['checkpoints']['fifth']->location)) ? $aValue['checkpoints']['fifth']->location : "-",
                    (!empty($aValue['checkpoints']['fifth']->expected_time)) ? $aValue['checkpoints']['fifth']->expected_time : "-",
                    (!empty($aValue['checkpoints']['fifth']->actual_reach_time)) ? $aValue['checkpoints']['fifth']->actual_reach_time : "-",
                    $aValue['average'] ? $aValue['average'] : "-"
                ); 

                $aData['excel'][] = array(
                    "",
                    //first
                     "",
                    (!empty($aValue['checkpoints']['first']->time_difference))? $aValue['checkpoints']['first']->time_difference : "-",
                    "",
                    //second
                    "",
                    (!empty($aValue['checkpoints']['second']->time_difference)) ? $aValue['checkpoints']['second']->time_difference : "-",
                    "",
                    //third
                    "",
                    (!empty($aValue['checkpoints']['third']->time_difference))? $aValue['checkpoints']['third']->time_difference : "-" ,
                    "",
                    //four
                    "",
                    (!empty($aValue['checkpoints']['fourth']->time_difference))	? $aValue['checkpoints']['fourth']->time_difference : "-",
                    "",
                    //fifth
                    "",
                    (!empty($aValue['checkpoints']['fifth']->time_difference))? $aValue['checkpoints']['fifth']->time_difference : "-",
                    "",
                    ""

                ); 
            }
        }else{
            $aData['excel'][] = array(
            );     
        }
        return $aData['excel'];
    }

    public function headings(): array
    {   
        $aData['division_id']     = Session::has('division_id') ? Session::get('division_id') : 0;
        $aData['ward_id']         = Session::has('ward_id') ? Session::get('ward_id') : 0;
        $aData['vehicle_id']      = Session::has('vehicle_id') ? Session::get('vehicle_id') : 0;
        $aData['vehicle_type_id'] = Session::has('vehicle_type_id') ? Session::get('vehicle_type_id') : 0;
        $aData['date']            = Session::has('date') ? Session::get('date') : date('d-m-Y',strtotime('now'));
   
        $division_name = "-";
        if($aData['division_id'] != 0){
            $div = DivisionModel::where('id', $aData['division_id'])->get('division_name');
            foreach($div as $val){
                $division_name = $val->division_name;
            }
        }

        $ward_name = "-";
        if($aData['ward_id'] != 0){
            $ward_id = DB::table('admin_wards')->where('id',  $aData['ward_id'])->get('ward_name'); 
            foreach($ward_id as $val){
                $ward_name = $val->ward_name;
            }
        }

        $vehicle_number = "-";
        if($aData['vehicle_id'] != 0){
            $vehicle= VehicleModel::where('id', $aData['vehicle_id'])->get('vehicle_number');
            foreach($vehicle as $val){
                $vehicle_number = $val->vehicle_number;
            }
        }

        $vehicle_types = "-";
        if($aData['vehicle_type_id'] != 0){
            $vehicle = DB::table('vehicle_types')->where('id',  $aData['vehicle_type_id'])->get('type'); 
            foreach($vehicle as $val){
                $vehicle_types = $val->type;
            }
        }
               
        return [
                ['Report Name: Checkpoint Arrival Consolidated Report .'],
                ['Division Name : '. $division_name ],
                ['Ward Name : '.$ward_name],
                ['Vehicle Number : '.$vehicle_number ],
                ['Vehicle Type : '.$vehicle_types ],
                ['Date : '. $aData['date']],
                [],
                [ 
                    'Vehicle Number	 ',
                    'Checkpoints ',
                    '',
                    '',
                    '',
                    '',
                    '',
                    '',
                    '',
                    '',
                    '',
                    '',
                    '',
                    '',
                    '',
                    '',
                    'Average '              
                ],
                [
                    '',
                    '1st ',
                    '',
                    '',
                    '2nd ',
                    '',
                    '',
                    '3rd ',
                    '',
                    '',
                    '4th ',
                    '',
                    '',
                    '5th ',
                    '',
                    '',
                    ''  
                ],
                [
                    '',
                    'Location ',
                    'Expected Time ',
                    'Actual Time ',
                    'Location ',
                    'Expected Time ',
                    'Actual Time ',
                    'Location ',
                    'Expected Time ',
                    'Actual Time ',
                    'Location ',
                    'Expected Time ',
                    'Actual Time ',
                    'Location ',
                    'Expected Time ',
                    'Actual Time ',
                    ''
                ]
            ];
    }

      /**
     * @return string
     */
    public function registerEvents(): array
    {
        return [
            AfterSheet::class => function(AfterSheet $event) {
                $event->sheet->getDelegate()->getStyle('A1:Z1265')->getAlignment()->setHorizontal('left');
                $event->sheet->getDelegate()->getStyle('B8:Q8')->getAlignment()->setHorizontal('center');
                $event->sheet->getDelegate()->getStyle('B8:Q8')->getAlignment()->setVertical('center');
                $event->sheet->getDelegate()->getStyle('B9:Z9')->getAlignment()->setHorizontal('center');
                $event->sheet->getDelegate()->getStyle('B9:Z9')->getAlignment()->setVertical('center');

                $event->sheet->getDelegate()->getStyle('A8:A10')->getAlignment()->setHorizontal('center');
                $event->sheet->getDelegate()->getStyle('A8:A10')->getAlignment()->setVertical('center');

                $event->sheet->getDelegate()->getStyle('R8:R10')->getAlignment()->setHorizontal('center');
                $event->sheet->getDelegate()->getStyle('R8:R10')->getAlignment()->setVertical('center');

                $event->sheet->getDelegate()->getStyle('A10:Z10')->getAlignment()->setHorizontal('center');
                $event->sheet->getDelegate()->getStyle('A10:Z10')->getAlignment()->setVertical('center');

                $event->sheet->mergeCells('A1:D1');
                $event->sheet->mergeCells('A2:D2');
                $event->sheet->mergeCells('A3:D3');
                $event->sheet->mergeCells('A4:D4');
                $event->sheet->mergeCells('A5:D5');
                $event->sheet->mergeCells('A6:D6');
                $event->sheet->mergeCells('A7:Z7');
                $event->sheet->mergeCells('B8:P8');
                $event->sheet->mergeCells('B9:D9');
                $event->sheet->mergeCells('E9:G9');
                $event->sheet->mergeCells('H9:J9');
                $event->sheet->mergeCells('K9:M9');
                $event->sheet->mergeCells('N9:P9');
                $event->sheet->mergeCells('A8:A10');
                $event->sheet->mergeCells('Q8:Q10');
                
                $aData = array();
                $aData['division_id']     = Session::has('division_id') ? Session::get('division_id') : 0;
                $aData['ward_id']         = Session::has('ward_id') ? Session::get('ward_id') : 0;
                $aData['vehicle_id']      = Session::has('vehicle_id') ? Session::get('vehicle_id') : 0;
                $aData['vehicle_type_id'] = Session::has('vehicle_type_id') ? Session::get('vehicle_type_id') : 0;
                $aData['date']            = Session::has('date') ? Session::get('date') : date('d-m-Y',strtotime('now'));
                $aData['records']      = VehicleTrakingReportModel::get_checkpoints_consolidated($aData);
                $rowSpan = 11;
                $p = 11;
                $colSpan = 12;

                foreach($aData['records'] as $key=>$aValue){ 
                    $rowSpan += 1;
                    //Applying Colors
                    if(!empty($aValue['checkpoints']['first']->second_with_sign)){
                        if($aValue['checkpoints']['first']->second_with_sign > 0) {
                            $event->sheet->getStyle('B'.$p.':D'.$rowSpan)->getFill()
                            ->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)
                            ->getStartColor()->setARGB('EFA1A1');
                        } 
                        elseif($aValue['checkpoints']['first']->second_with_sign < 0){
                            $event->sheet->getStyle('B'.$p.':D'.$rowSpan)->getFill()
                            ->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)
                            ->getStartColor()->setARGB('00FF7F');
                        }      
                    }  

                    if(!empty($aValue['checkpoints']['second']->second_with_sign)){
                        if($aValue['checkpoints']['second']->second_with_sign > 0){
                            $event->sheet->getStyle('E'.$p.':G'.$rowSpan)->getFill()
                            ->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)
                            ->getStartColor()->setARGB('EFA1A1');
                        } 
                          
                        elseif($aValue['checkpoints']['second']->second_with_sign < 0){
                            $event->sheet->getStyle('E'.$p.':G'.$rowSpan)->getFill()
                            ->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)
                            ->getStartColor()->setARGB('00FF7F');
                        } 
                    }

                    if(!empty($aValue['checkpoints']['third']->second_with_sign)){
                        if($aValue['checkpoints']['third']->second_with_sign > 0){
                            $event->sheet->getStyle('H'.$p.':J'.$rowSpan)->getFill()
                            ->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)
                            ->getStartColor()->setARGB('EFA1A1');
                        }
                        elseif($aValue['checkpoints']['third']->second_with_sign < 0){
                            $event->sheet->getStyle('H'.$p.':J'.$rowSpan)->getFill()
                            ->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)
                            ->getStartColor()->setARGB('00FF7F');
                        }
                    }

                    if(!empty($aValue['checkpoints']['fourth']->second_with_sign)){
                        if($aValue['checkpoints']['fourth']->second_with_sign > 0){
                            $event->sheet->getStyle('K'.$p.':M'.$rowSpan)->getFill()
                            ->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)
                            ->getStartColor()->setARGB('EFA1A1');
                        }	
                        elseif($aValue['checkpoints']['fourth']->second_with_sign < 0){
                            $event->sheet->getStyle('K'.$p.':M'.$rowSpan)->getFill()
                            ->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)
                            ->getStartColor()->setARGB('00FF7F');
                        }
                    }

                    if(!empty($aValue['checkpoints']['fifth']->second_with_sign)){
                        if($aValue['checkpoints']['fifth']->second_with_sign > 0){
                            $event->sheet->getStyle('N'.$p.':P'.$rowSpan)->getFill()
                            ->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)
                            ->getStartColor()->setARGB('EFA1A1');
                        }
                        elseif($aValue['checkpoints']['fifth']->second_with_sign < 0){
                            $event->sheet->getStyle('N'.$p.':P'.$rowSpan)->getFill()
                            ->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)
                            ->getStartColor()->setARGB('00FF7F');
                        }
                    }

                    //Column
                    $event->sheet->mergeCells('C'.$colSpan.':D'.$colSpan);
                    $event->sheet->mergeCells('F'.$colSpan.':G'.$colSpan);
                    $event->sheet->mergeCells('I'.$colSpan.':J'.$colSpan);
                    $event->sheet->mergeCells('L'.$colSpan.':M'.$colSpan);
                    $event->sheet->mergeCells('O'.$colSpan.':P'.$colSpan);

                    $event->sheet->getDelegate()->getStyle('C'.$colSpan.':D'.$colSpan)->getAlignment()->setHorizontal('center');
                    $event->sheet->getDelegate()->getStyle('C'.$colSpan.':D'.$colSpan)->getAlignment()->setVertical('center');
                    $event->sheet->getDelegate()->getStyle('F'.$colSpan.':G'.$colSpan)->getAlignment()->setHorizontal('center');
                    $event->sheet->getDelegate()->getStyle('F'.$colSpan.':G'.$colSpan)->getAlignment()->setVertical('center');
                    $event->sheet->getDelegate()->getStyle('I'.$colSpan.':J'.$colSpan)->getAlignment()->setHorizontal('center');
                    $event->sheet->getDelegate()->getStyle('I'.$colSpan.':J'.$colSpan)->getAlignment()->setVertical('center');
                    $event->sheet->getDelegate()->getStyle('L'.$colSpan.':M'.$colSpan)->getAlignment()->setHorizontal('center');
                    $event->sheet->getDelegate()->getStyle('L'.$colSpan.':M'.$colSpan)->getAlignment()->setVertical('center');
                    $event->sheet->getDelegate()->getStyle('O'.$colSpan.':P'.$colSpan)->getAlignment()->setHorizontal('center');
                    $event->sheet->getDelegate()->getStyle('O'.$colSpan.':P'.$colSpan)->getAlignment()->setVertical('center');

                     //Row Span
                    $event->sheet->mergeCells('A'.$p.':A'.$rowSpan);
                    $event->sheet->mergeCells('B'.$p.':B'.$rowSpan);
                    $event->sheet->mergeCells('E'.$p.':E'.$rowSpan);
                    $event->sheet->mergeCells('H'.$p.':H'.$rowSpan);
                    $event->sheet->mergeCells('K'.$p.':K'.$rowSpan);
                    $event->sheet->mergeCells('N'.$p.':N'.$rowSpan);
                    $event->sheet->mergeCells('Q'.$p.':Q'.$rowSpan);

                    $event->sheet->getDelegate()->getStyle('A'.$p.':A'.$rowSpan)->getAlignment()->setHorizontal('left');
                    $event->sheet->getDelegate()->getStyle('A'.$p.':A'.$rowSpan)->getAlignment()->setVertical('center');
                    $event->sheet->getDelegate()->getStyle('B'.$p.':B'.$rowSpan)->getAlignment()->setHorizontal('left');
                    $event->sheet->getDelegate()->getStyle('B'.$p.':B'.$rowSpan)->getAlignment()->setVertical('center');
                    $event->sheet->getDelegate()->getStyle('E'.$p.':E'.$rowSpan)->getAlignment()->setHorizontal('left');
                    $event->sheet->getDelegate()->getStyle('E'.$p.':E'.$rowSpan)->getAlignment()->setVertical('center');
                    $event->sheet->getDelegate()->getStyle('H'.$p.':H'.$rowSpan)->getAlignment()->setHorizontal('left');
                    $event->sheet->getDelegate()->getStyle('H'.$p.':H'.$rowSpan)->getAlignment()->setVertical('center');
                    $event->sheet->getDelegate()->getStyle('K'.$p.':K'.$rowSpan)->getAlignment()->setHorizontal('left');
                    $event->sheet->getDelegate()->getStyle('K'.$p.':K'.$rowSpan)->getAlignment()->setVertical('center');
                    $event->sheet->getDelegate()->getStyle('N'.$p.':N'.$rowSpan)->getAlignment()->setHorizontal('left');
                    $event->sheet->getDelegate()->getStyle('N'.$p.':N'.$rowSpan)->getAlignment()->setVertical('center');
                    $event->sheet->getDelegate()->getStyle('Q'.$p.':Q'.$rowSpan)->getAlignment()->setHorizontal('left');
                    $event->sheet->getDelegate()->getStyle('Q'.$p.':Q'.$rowSpan)->getAlignment()->setVertical('center');
                    $rowSpan ++;
                    $p =  $rowSpan;
                    $colSpan = $colSpan+2;
                }

                $event->sheet->getDelegate()->getRowDimension('1')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('2')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('3')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('4')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('5')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('6')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('8')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('9')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('10')->setRowHeight(25);
              
                $event->sheet->getStyle('A1:Z10')->applyFromArray([
                    'font'=>[
                            'bold'=>true,
                    ]
                ]);

            },
        ];
    }
  
}

