<?php

namespace App\Exports;

use Maatwebsite\Excel\Concerns\FromArray;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithEvents;
use Illuminate\Support\Facades\Session;
use App\Models\ReportModel;
use Maatwebsite\Excel\Events\AfterSheet;
use Illuminate\Support\Facades\DB;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing;

class EmployeeExport implements FromArray,WithHeadings,ShouldAutoSize,WithEvents
{
    protected $data;
    protected $headings;
    protected $columnWidth = [];
    protected $rowHeight = [];
    protected $mergeCells = [];
    protected $font = [];
    protected $fontSize = [];
    protected $bold = [];
    protected $background = []; 
    protected $vertical = []; 
    protected $sheetName;
    protected $borders = [];

    /**
    * @return \Illuminate\Support\Collection
    */
    public function array(): array
    {
        $aData['Pakage_id'] = session::has('Pakage_id') ? session::get('Pakage_id') : 0;

        $aData['aEmployee'] = ReportModel::get_all_employee($aData)->get();
        $aData['excel'] = array();
        foreach($aData['aEmployee'] as $val){
        
            $aData['excel'][] = array(
                'employee_id' => $val->emp_id,
                'name' => $val->name,
                'Pakage_name' => $val->Pakage_name ? $val->Pakage_name : "-",
                'gender' => $val->gender ? $val->gender : "-",
                'designation' => $val->designation_name ? $val->designation_name : "-",
                'address' => $val->address,
            );     
        }
        return $aData['excel'];
    }

    

    public function headings(): array
    {   
        $aData['Pakage_id'] = session::has('Pakage_id') ? session::get('Pakage_id') : 0;

        $result = DB::table('admin_pakages')
                ->where('id', $aData['Pakage_id'])
                ->get();
        
        foreach($result as $val){
            $Pakage_name  = $val->Pakage_name ;
        }

        if(!empty($Pakage_name)){
            $package  = $Pakage_name;
        }  
        else{
            $package  = '-';
        }

        return [
                ['Report Name: All Employees Report.'],
                ['Pakage Name :'.$package.'' ],
                [],
                [ 
                    'Employee Id ',
                    'Name  ',
                    'Pakage Name ',
                    'Gender  ',
                    'Designation  ',
                    'Address ',
                    'Photo ' 
                ]
            ];
    }

      /**
     * @return string
     */
    public function registerEvents(): array
    {
        
        return [
            AfterSheet::class => function(AfterSheet $event) {
                $event->sheet->getDelegate()->getStyle('A1:Z1265')->getAlignment()->setHorizontal('left');

                $event->sheet->mergeCells('A1:C1');
                $event->sheet->mergeCells('A2:C2');
                $event->sheet->mergeCells('A3:Z3');

                $event->sheet->getDelegate()->getRowDimension('1')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('2')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('4')->setRowHeight(25);

                $event->sheet->getStyle('A1:Z4')->applyFromArray([
                    'font'=>[
                            'bold'=>true,
                            
                    ]
                
                ]);
                $workSheet = $event->sheet->getDelegate();
                foreach ($this->getDrawings() as $drawing) {
                    $drawing->setWorksheet($workSheet);
                }

            },
        ];
    }
    
    public function getDrawings():array
    {
        $aData['Pakage_id'] = session::has('Pakage_id') ? session::get('Pakage_id') : 0;
        $aData['aEmployee'] = ReportModel::get_all_employee($aData)->get();
        $rowNum = 5;
        $drawings = [];
        foreach ($aData['aEmployee'] as $val) {
            $drawing = new Drawing();
            if($val->image_url){
                $drawing->setPath(public_path('/uploads/employee_images/'.$val->image_url));
            }else{
                $drawing->setPath(public_path('app-assets/images/portrait/small/proflie-default.png'));
            }
          
            $drawing->setCoordinates('G'.$rowNum);
            $drawing->setHeight(25);
            $drawing->setWidth(25);
            $drawings[] = $drawing;
            $rowNum++;
        }

        return $drawings;

    }
    
   
}

