<?php

namespace App\Exports;

use Maatwebsite\Excel\Concerns\FromArray;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithEvents;
use Illuminate\Support\Facades\Session;
use App\Models\ReportModel;
use Maatwebsite\Excel\Events\AfterSheet;
use Illuminate\Support\Facades\DB;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing;


class InvalidEntriesExport implements FromArray,WithHeadings,ShouldAutoSize,WithEvents
{
    protected $data;
    protected $headings;
    protected $columnWidth = [];
    protected $rowHeight = [];
    protected $mergeCells = [];
    protected $font = [];
    protected $fontSize = [];
    protected $bold = [];
    protected $background = []; 
    protected $vertical = []; 
    protected $sheetName;
    protected $borders = [];

    /**
    * @return \Illuminate\Support\Collection
    */
    public function array(): array
    {
        $aData = array();
        $aData['Pakage_id'] = session::has('Pakage_id') ? session::get('Pakage_id') : "";
        $aData['start_date'] = session::has('start_date') ? session::get('start_date') : date('d-m-Y',strtotime('-1 month'));
        $aData['end_date'] = session::has('end_date') ? session::get('end_date') :date('d-m-Y');

        $aEmployeeData = ReportModel::getInvalidData($aData);

        foreach($aEmployeeData as $key=>$data){
			$aEmployeeData[$key]->current_day = date('Ymd',$data->attendance_date);
			if($data->inward_datetime < $data->outword_datetime AND !empty($data->inward_datetime) AND !empty($data->outword_datetime)){	
				$hours = ReportModel::secondsToTime($data->hours);
				$aEmployeeData[$key]->hours = $hours['h'].':'.$hours['m'];
			}	
			else{
				$aEmployeeData[$key]->hours = '';
            }
		}
        if($aEmployeeData){
            foreach($aEmployeeData as $key=>$val){
                $aData['excel'][] = array(
                    'pakage_name' => $val->Pakage_name,
                    'attendance_date' => date("d-m-Y",$val->attendance_date),
                    'emp_id' => $val->emp_id,
                    'employee' => $val->employee,
                    'inward_datetime' => date("H:i",$val->inward_datetime),
                    'in_location' => $val->in_location,
                    '',
                    'outword_datetime' => $val->outword_datetime ? date("H:i",$val->outword_datetime) : "-",
                    'out_location' => $val->out_location ?  $val->out_location : "-",
                    '',
                    'success' => $val->success ? "Present" : "Absent",
                    'hours' => $val->hours ? $val->hours : "-"
                );     
            }
        }else{
            $aData['excel'][] = array(
            );     
        }
        
        return $aData['excel'];
    }

    public function headings(): array
    {        
        $aData['Pakage_id'] = session::has('Pakage_id') ? session::get('Pakage_id') : "";
        $aData['start_date'] = Session::has('start_date') ? Session::get('start_date') : date('d-m-Y',strtotime('-1 month'));
        $aData['end_date'] = Session::has('end_date') ? Session::get('end_date') :date('d-m-Y');

        $result = DB::table('admin_pakages')
                ->where('id', $aData['Pakage_id'])
                ->get();
        
        foreach($result as $val){
            $pakage_name  = $val->Pakage_name ;
        }

        if(!empty($pakage_name)){
            $division  = $pakage_name;
        }  
        else{
            $division  = '-';
        }

        return [
                ['Report Name: Invalid Entries Report.'],
                ['Start Date :'.$aData['start_date']],
                ['End Date :'.$aData['end_date']],
                ['Pakage :'.$division.'' ],
                [],
                [ 
                    'Pakage Name',
                    'Date',
                    'Emp Code',
                    'Emp Name',
                    'Login Time',
                    'Login Location',
                    'Login Image',
                    'Logout Time',
                    'Logout Location',
                    'Logout Image',
                    'Status',
                    'Hours'
                ]
            ];
    }

      /**
     * @return string
     */
    public function registerEvents(): array
    {
        return [
            AfterSheet::class => function(AfterSheet $event) {
                $event->sheet->getDelegate()->getStyle('A1:Z1265')->getAlignment()->setHorizontal('left');
                $event->sheet->mergeCells('A1:C1');
                $event->sheet->mergeCells('A2:C2');
                $event->sheet->mergeCells('A3:C3');
                $event->sheet->mergeCells('A4:C4');
                $event->sheet->mergeCells('A5:Z5');

                $event->sheet->getDelegate()->getRowDimension('1')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('2')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('3')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('4')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('6')->setRowHeight(25);

                $event->sheet->getStyle('A1:Z6')->applyFromArray([
                    'font'=>[
                            'bold'=>true,
                    ]
                ]);

                 //display images
                 $workSheet = $event->sheet->getDelegate();
                 foreach ($this->getDrawings("a") as $drawing) {
                     $drawing->setWorksheet($workSheet);
                 }
 
                 foreach ($this->getDrawings("b") as $drawing) {
                     $drawing->setWorksheet($workSheet);
                 }
            },
        ];
    }
    
    public function getDrawings($a):array
    {
        $aData = array();
        $aData = array();
        $aData['Pakage_id'] = session::has('Pakage_id') ? session::get('Pakage_id') : "";
        $aData['start_date'] = session::has('start_date') ? session::get('start_date') : date('d-m-Y',strtotime('-1 month'));
        $aData['end_date'] = session::has('end_date') ? session::get('end_date') :date('d-m-Y');

        $aEmployeeData = ReportModel::getInvalidData($aData);
        foreach($aEmployeeData as $key=>$data){
			$aEmployeeData[$key]->current_day = date('Ymd',$data->attendance_date);
			if($data->inward_datetime < $data->outword_datetime AND !empty($data->inward_datetime) AND !empty($data->outword_datetime)){	
				$hours = ReportModel::secondsToTime($data->hours);
				$aEmployeeData[$key]->hours = $hours['h'].':'.$hours['m'];
			}	
			else{
				$aEmployeeData[$key]->hours = '';
            }
		}
        $rowNum = 7;
        $drawings = [];
        
        foreach ($aEmployeeData as $val) {
            $drawing = new Drawing();
            if($a == "a"){
                if($val->in_image_url){
                    $drawing->setPath(public_path('attendance/' .$val->current_day.'/'.$val->in_image_url));
                    $drawing->setCoordinates('G'.$rowNum);
                }else{
                    $drawing->setPath(public_path('app-assets/images/portrait/small/proflie-default.png'));
                    $drawing->setCoordinates('G'.$rowNum);
                }
            }
            
            if($a == "b"){
                if($val->out_image_url){
                    $drawing->setPath(public_path('attendance/' .$val->current_day.'/'. $val->out_image_url));
                    $drawing->setCoordinates('J'.$rowNum);
                }else{
                    $drawing->setPath(public_path('app-assets/images/portrait/small/proflie-default.png'));
                    $drawing->setCoordinates('J'.$rowNum);
                }
            }

            $drawing->setHeight(25);
            $drawing->setWidth(25);
            $drawings[] = $drawing;
            $rowNum++;
        }
        return $drawings;
    }
}

