<?php

namespace App\Exports;

use App\Models\VehicleModel;
use App\Models\DivisionModel;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Session;
use Maatwebsite\Excel\Events\AfterSheet;
use App\Models\VehicleTrakingReportModel;
use Maatwebsite\Excel\Concerns\FromArray;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;

class WeightMngtPayableAmtExport implements FromArray,WithHeadings,ShouldAutoSize,WithEvents
{
    protected $data;
    protected $headings;
    protected $columnWidth = [];
    protected $rowHeight = [];
    protected $mergeCells = [];
    protected $font = [];
    protected $fontSize = [];
    protected $bold = [];
    protected $background = []; 
    protected $vertical = []; 
    protected $sheetName;
    protected $borders = [];

    /**
    * @return \Illuminate\Support\Collection
    */
    public function array(): array
    {
        $aData = array();
        $aData['vehicle_type'] = "0";
        $aData['division_id']     = session::has('division_id') ? session::get('division_id') : 0;
        $aData['start_day']       = session::has('start_day') ? session::get('start_day') : 1;
        $aData['end_day']         = session::has('end_day') ? session::get('end_day') : date('d',strtotime('now'));
        $aData['month']           = session::has('month') ? session::get('month') : date('m',strtotime('now'));
        $aData['year']            = session::has('year') ? session::get('year') : date('Y',strtotime('now'));
        $aData['division_id']     = session::has('division_id') ? session::get('division_id') : 0;
        // dd($aData['end_day'] );

        $aData['records']      = VehicleTrakingReportModel::get_weight_mngt_payable_amt($aData);
        if( $aData['records']){
            foreach($aData['records']['data'] as $aValue){ 
                $aData['excel'][] = array(
                    'date' => date('d-m-Y',strtotime($aValue['current_day'])),
                    'total_loaded' =>  $aValue['total_loaded'] ?  $aValue['total_loaded'] : "0",
                    'total_unloaded' =>  $aValue['total_unloaded'] ?  $aValue['total_unloaded'] : "0",
                    'total_net' =>  $aValue['total_net'] ? $aValue['total_net'] : "0",
                    'tons' =>  $aValue['tons'] ? $aValue['tons'] : "0",
                    'payable_amount' =>  $aValue['payable_amount'] ?  $aValue['payable_amount'] : "0",
                    'absentFine' =>  $aValue['absentFine'] ? preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $aValue['absentFine']) :"0" ,
                    'missing_employeesFine' =>  $aValue['missing_employeesFine'] ? preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $aValue['missing_employeesFine']) : "0",
                    'chekpointFine' =>  $aValue['chekpointFine'] ? preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $aValue['chekpointFine']) : "0" ,
                    'chekpointFine_time_deviation' =>  $aValue['chekpointFine_time_deviation'] ?preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $aValue['chekpointFine_time_deviation']) : "0" ,
                    'deviation_fine' =>  $aValue['deviation_fine'] ? preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $aValue['deviation_fine']) : "0",
                    'total_fine_amount' =>  $aValue['total_fine_amount'] ? $aValue['total_fine_amount'] : "0",
                    'net_payable_amount' =>  $aValue['net_payable_amount'] ? $aValue['net_payable_amount'] : "0",
                ); 
            }
            $aData['excel'][] = array(
                'Total'  => 'Total',
                '',
                '',  
                '',        
                'total_tons' =>  $aData['records']['total']['total_tons'] ? $aData['records']['total']['total_tons'] : "0",
                'total_payable_amt' =>  $aData['records']['total']['total_payable_amt'] ? $aData['records']['total']['total_payable_amt'] : "0",
                'otal_absentFine ' =>  $aData['records']['total']['total_absentFine'] ? $aData['records']['total']['total_absentFine'] : "0",
                'total_missing_employeesFine' =>  $aData['records']['total']['total_missing_employeesFine'] ? $aData['records']['total']['total_missing_employeesFine'] : "0",
                'total_chekpointFine' =>  $aData['records']['total']['total_chekpointFine'] ?  $aData['records']['total']['total_chekpointFine'] : "0",
                'total_chekpointFine_time_deviation' =>  $aData['records']['total']['total_chekpointFine_time_deviation'] ?  $aData['records']['total']['total_chekpointFine_time_deviation'] : "0",
                'total_deviation_fine' =>  $aData['records']['total']['total_deviation_fine'] ? $aData['records']['total']['total_deviation_fine'] : "0",
                'total_fine' =>  $aData['records']['total']['total_fine'] ? $aData['records']['total']['total_fine'] : "0", 
                'total_net_payable_amount' =>  $aData['records']['total']['total_net_payable_amount'] ? $aData['records']['total']['total_net_payable_amount'] : "0"
        ); 
        }else{
            $aData['excel'][] = array(
            );     
        }
        return $aData['excel'];
    }

    public function headings(): array
    {   
        $aData = array();
        $aData['vehicle_type'] = "0";
        $aData['division_id']     = session::has('division_id') ? session::get('division_id') : 0;
        $aData['start_day']       = session::has('start_day') ? session::get('start_day') : 1;
        $aData['end_day']         = session::has('end_day') ? session::get('end_day') : date('d',strtotime('now'));
        $aData['month']           = session::has('month') ? session::get('month') : date('m',strtotime('now'));
        $aData['year']            = session::has('year') ? session::get('year') : date('Y',strtotime('now'));
        $aData['division_id']     = session::has('division_id') ? session::get('division_id') : 0;

        $month = "";
        $aData['aMonths'] = config('custom.months');
        foreach($aData['aMonths'] as $key => $value){
            if($aData['month'] == $key){
                $month = $value;
            }
        }
       
        $division_name = "-";
        if($aData['division_id'] != 0){
            $div = DivisionModel::where('id', $aData['division_id'])->get('division_name');
            foreach($div as $val){
                $division_name = $val->division_name;
            }
        }   
        return [
                ['Report Name: Weight Management - Payable Amount Report.'],
                ['Division Name : '.$division_name ],
                ['Start Day : '.$aData['start_day']],
                ['End Day : '.$aData['end_day']],
                ['Month : '.$month],
                ['Year : '.$aData['year']],
                [],
                [ 
                    'Date',
                    'Loaded Weight',
                    'Unloaded Weight',
                    'Net Weight',
                    'Tons',
                    'Payable Amount',
                    'Vehicle Absent Fine',
                    'Biometric Attendance Fine',
                    'Failed Checkpoints Fine',
                    'Time Deviation (Checkpoints) Fine',  
                    'Deviation Fine',
                    'Total Fine',
                    'Net Payable Amount'                 
                ]
        ];
    }

      /**
     * @return string
     */
    public function registerEvents(): array
    {
        return [
            AfterSheet::class => function(AfterSheet $event) {
                $event->sheet->getDelegate()->getStyle('A1:Z1265')->getAlignment()->setHorizontal('left');
                $event->sheet->getStyle('A1:Z8')->applyFromArray([
                    'font'=>[
                            'bold'=>true,
                    ]
                ]);
                $event->sheet->getDelegate()->getRowDimension('1')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('2')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('3')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('4')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('5')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('6')->setRowHeight(25);
                $event->sheet->getDelegate()->getRowDimension('8')->setRowHeight(25);

                $event->sheet->mergeCells('A1:D1');
                $event->sheet->mergeCells('A2:D2');
                $event->sheet->mergeCells('A3:D3');
                $event->sheet->mergeCells('A4:D4');
                $event->sheet->mergeCells('A5:D5');
                $event->sheet->mergeCells('A6:D6');
                $event->sheet->mergeCells('A7:Z7');
                
                $aData['vehicle_type'] = "0";
                $aData['division_id']     = session::has('division_id') ? session::get('division_id') : 0;
                $aData['start_day']       = session::has('start_day') ? session::get('start_day') : 1;
                $aData['end_day']         = session::has('end_day') ? session::get('end_day') : date('d',strtotime('now'));
                $aData['month']           = session::has('month') ? session::get('month') : date('m',strtotime('now'));
                $aData['year']            = session::has('year') ? session::get('year') : date('Y',strtotime('now'));
                $aData['division_id']     = session::has('division_id') ? session::get('division_id') : 0;
            
                $aData['records']      = VehicleTrakingReportModel::get_weight_mngt_payable_amt($aData);
                $i = 9;
                if($aData['records']['data']){
                    $data = count($aData['records']['data']);
                    $i += $data;
                    $event->sheet->getStyle('A'.$i.':Z'.$i)->applyFromArray([
                        'font'=>[
                                'bold'=>true,
                        ]
                    ]);
                    $event->sheet->mergeCells('A'.$i.':D'.$i);
                    $event->sheet->getDelegate()->getStyle('A'.$i.':D'.$i)->getAlignment()->setHorizontal('right');
                }

            },
        ];
    }
  
}

