<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\RouteModel;
use App\Models\VehicleModel;
use App\Models\VehicleRoute;
use App\Libraries\Mysecurity;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\DB;

class CalendarController extends Controller
{
    
    public function __construct()
    {
        
        $this->route_model = new RouteModel();

        $module_link = request()->segments(0);
        if(isset($module_link[0])){
            $module_link = $module_link[0];
            $this->mysecurity = new Mysecurity();
            $this->module_id = $this->mysecurity->get_module_id_by_name($module_link);
            $this->middleware(function ($request, $next){
                $this->mysecurity->check_access(Session::get('logged_in')['id'],$this->module_id,1);
        
                return $next($request);
            });
        }
    }

    public function list(Request $request,$route_id='',$vehicle_id='',$start_date=''){
        
        $aData = array();
        
        $aData['txt_from_date'] = '';
        $aData['txt_to_date'] = '';
        $aData['vehicle_id'] = '';
        $aData['route_id'] = '';
        $aData['search'] = '';

        if((!empty($request->input('form_type'))) || (!empty($route_id) && !empty($vehicle_id) && !empty($start_date))){

            if(empty($request->input('form_type')) && !empty($route_id) && !empty($vehicle_id) && !empty($start_date)){  // route through redirect veiw calendar
                

                $txt_from_date   = base64_decode($start_date);
                $txt_to_date     = date('d-m-Y',strtotime('+30 day',strtotime($txt_from_date)));
                $vehicle_id      = $vehicle_id;
                $route_id        = $route_id;
            }else{

               $txt_from_date   = $request->input('txt_from_date');
               $txt_to_date     = $request->input('txt_to_date');
               $vehicle_id      = $request->input('vehicle_number');
               $route_id        = $request->input('route_id');
            }
           
           

            if(!empty($txt_from_date) || !empty($txt_to_date) || !empty($vehicle_id) || !empty($route_id)){
             $aData['search'] = 1;
            }

           $aData['txt_from_date'] = $txt_from_date;
           $aData['txt_to_date'] = $txt_to_date;
           $aData['vehicle_id'] = $vehicle_id;
           $aData['route_id'] = $route_id;

            $txt_from_date1 = date('Ymd',strtotime($txt_from_date));
            $txt_to_date1   = date('Ymd',strtotime($txt_to_date));

            //echo $txt_from_date1.'<br>'.$txt_to_date1;die();

             $records = [];

            while ($txt_from_date1 <= $txt_to_date1) {
              
               
               $sql = 'SELECT rm.*,vm.vehicle_number FROM route_master rm LEFT JOIN vehicle_master vm ON vm.id = rm.vehicle_id  where 1=1';

                 if(!empty($vehicle_id)){

                    $sql .= ' AND vm.id = '.$vehicle_id;
                 }

                 if(!empty($route_id)){

                    $sql .= ' AND rm.id = '.$route_id;
                 }

                 $aPakages_id = Session::get('Pakages');

                 $aLoggedIn = Session::get('logged_in'); 

                 if($aLoggedIn['superuser'] !=1 && $aLoggedIn['subadmin'] !=1){

                    $str_div = ($aPakages_id)?implode(',',$aPakages_id):0;
                        $sql .= ' AND rm.Pakage_id IN ('.$str_div.')';
                }

                 // echo $sql.'<br>';
              $r_result = DB::select($sql);
                
                if (count($r_result) > 0) {

                    foreach ($r_result as $row) {

                        $vehicle_number = 0;
                        $route_name = 0;
                       
                        if ($row->repeat_how_many_days != 0 && ($txt_from_date1 - $row->start_date) % $row->repeat_how_many_days == 0) {
                            
                            $vehicle_number = $row->vehicle_number;
                            $route_name = $row->route_name;
                        }

                        $record = [
                            'date' => $txt_from_date1,
                            'route_name' => $route_name,
                            'vehicle' => $vehicle_number,
                        ];

                        // Add the current record to the array
                        $records[] = $record;
      
                     
                    }


                }

                 $aData['records'] = $records;

                 $txt_from_date1 = date('Ymd', strtotime('+1 day', strtotime($txt_from_date1)));
            }

           

           //echo '<pre>';print_r($aData['records']);

          
           //die; 
           
        }

        $aData['vehicle'] = VehicleModel::get_vehicle()->orderBy('vehicle_number', 'ASC')->get();
        $aData['aRoutes'] = VehicleRoute::get_route()->orderBy('route_name', 'ASC')->get();
        

        return view('calendar.list', $aData);
    }

    public function clear_search(){

        return redirect(url('/calendar'));
    }
}
