<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\RouteModel;
use App\Models\VehicleModel;
use App\Models\WardModel;
use App\Models\HomeModel;
use App\Models\VehicleTrakingReportModel;
use App\Models\VehicleRoute;
use App\Models\PakageModel;
use App\Models\DesignationModel;
use App\Libraries\Mysecurity;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\DB;


class HomeController extends Controller
{   
    // public function __construct()
    // {
    //     $module_link = request()->segments(0);
    //     if(isset($module_link[0])){
    //         $module_link = $module_link[0];
    //         $this->mysecurity = new Mysecurity();
    //         $this->module_id = $this->mysecurity->get_module_id_by_name($module_link);
    //         $this->middleware(function ($request, $next){
    //             $this->mysecurity->check_access(Session::get('logged_in')['id'],$this->module_id,1);
        
    //             return $next($request);
    //         });
    //     }
    // }

    public function clear_search(){
        session::forget('Pakage_id');
        session::forget('vehicle_id');
        session::forget('vehicle_type');
        session::forget('route_id');
        return redirect()->route('home.search');
    }

    public function admin_clear_search(){
        session::forget('date');
        session::forget('start_date');
        session::forget('end_date');
        return redirect()->route('home.admin_dashboard_details');
    }

    public function index(Request $request)
    {   
        if(isset($request->Pakage_id)){
            //dd($request->Pakage_id);
            session::put(['Pakage_id' => $request->Pakage_id]);
        }

        if(isset($request->vehicle_id)){
            session::put(['vehicle_id' => $request->vehicle_id]);
        }

        if(isset($request->vehicle_type)){
            session::put(['vehicle_type' => $request->vehicle_type]);
        }

        if(isset($request->route_id)){
            session::put(['route_id' => $request->route_id]);
        }

        $aData['Pakage_id']   = session::has('Pakage_id') ? session::get('Pakage_id') : 0;
        $aData['vehicle_id']    = session::has('vehicle_id') ? session::get('vehicle_id') : 0;
        $aData['vehicle_type_id']  = session::has('vehicle_type') ? session::get('vehicle_type') : 0;
        $aData['route_id']  = session::has('route_id') ? session::get('route_id') : 0;
        
        if(!empty($aData['Pakage_id']) || !empty($aData['vehicle_id']) || !empty($aData['vehicle_type_id']) || !empty($aData['route_id']) ){
            $aData['search'] = 1;
        }

        $aData['present_count'] = RouteModel::get_present_count($aData);

        $aData['Pakages']      = VehicleModel::get_Pakages()->orderBy('Pakage_name', 'ASC')->get();
        $aData['vehicle']      = VehicleModel::get_vehicle()->orderBy('vehicle_number', 'ASC')->get();
        $aData['vehicle_type'] = DB::table('vehicle_types')->get();
        $aData['aRoutes']      = VehicleRoute::get_route()->orderBy('route_name', 'ASC')->get();

       return view('home.dashboard_new', $aData);
    }

    public function get_markers(Request $request){
       $aSearch = array();
       $aSearch['Pakage_id']      = session::has('Pakage_id') ? session::get('Pakage_id') : 0;
       //dd($aSearch['Pakage_id']);
       $aSearch['vehicle_id']       = session::has('vehicle_id') ? session::get('vehicle_id') : 0;
       $aSearch['vehicle_type_id']  = session::has('vehicle_type') ? session::get('vehicle_type') : 0;

       $aLocations = RouteModel::get_latest_locations($aSearch);
       //dd($aLocations);
       echo json_encode($aLocations);
    }

    public function get_prabhag_boundray(Request $request){
        $aSearch = array();
        $aSearch['ward_id']          = session::has('ward_id') ? session::get('ward_id') : 0;
        //print_r($aSearch['ward_id']); die;
        $aBoundray = RouteModel::get_prabhag_boundray($aSearch);
        echo json_encode($aBoundray);
    }

    public function user_dashboard_details(Request $request,$package_id){
        
        $aData = array();

        $aData['txt_date'] = (!empty(session('current_day'))) ? session('current_day') : date('d-m-Y');

        $emp_data_total = config('custom.emp_data_total');

        $emp_total = 0;
        
        $aData['Pakages'] = array();
        if(!empty(session('Pakages'))){

            $str_Pakages = implode(',',session('Pakages'));

            $qury = 'SELECT id,Pakage_name FROM admin_pakages where active = 1 AND id IN ('.$str_Pakages.')';
            $r_result = DB::select($qury);

            $aData['Pakages'] =  $r_result;
        } 

        
        $aData['logged_in'] = session('logged_in');


        /* Employee Attendance */

        $att_qury = 'SELECT SUM(CASE WHEN success = 1 THEN 1 ELSE 0 END) AS present_count FROM users_attendance WHERE 1=1 AND attendance_date='.strtotime($aData['txt_date']);

        if($aData['logged_in']['superuser'] !=1 && $aData['logged_in']['subadmin'] !=1){

            $str_div = (session('Pakages'))?implode(',',session('Pakages')):0;
                $att_qury .= ' AND Pakage_id IN ('.$str_div.')';

                if(!empty(session('Pakages'))){

                    for ($i=0; $i < count(session('Pakages')) ; $i++) { 

                      $emp_total += array_sum(array_column($emp_data_total[session('Pakages')[$i]], 'total'));
        
                    }
                }
        }else{
           
                $att_qury .= ' AND Pakage_id = '.$package_id;
                    
                $emp_total += array_sum(array_column($emp_data_total[$package_id], 'total'));
                //$total += 12;
        }
        
        $r_att_result = DB::select($att_qury);

        $aData['employee_count'] =  ['present_count' => $r_att_result[0]->present_count,'total_count' => $emp_total];

        /* end */


        /* Vehicle Attendance */

        $vehicle_att_data_total = config('custom.vehicle_att_data_total');

        $veh_total = 0;

        $daily_vehicle_att_pre_tot = 0;

        if($aData['logged_in']['superuser'] !=1 && $aData['logged_in']['subadmin'] !=1){
          
          if(!empty(session('Pakages'))){
            

            $loc_package_id = session('Pakages');
 
          } 
        }else{
         
            if(!empty($package_id)){
              
              $loc_package_id = explode(',',$package_id);
            }

        }
         
        if(!empty($loc_package_id)){ 

            for ($i=0; $i < count($loc_package_id) ; $i++) { 

                $veh_total += array_sum(array_column($vehicle_att_data_total[$loc_package_id[$i]], 'total'));

               $i_current_date = date('Ymd',strtotime($aData['txt_date']));
               // echo $i_current_date;die;
                
                $aData['vehicle_types'] = VehicleModel::get_vehicle_types();
                //echo '<pre>';print_r($data['vehicle_types']);die;

                    $aSeach['packege_id'] = $loc_package_id[$i];
                    $r_route_data_res = RouteModel::get_to_fetch_route($aSeach);
                    //echo '<pre>';print_r($r_vehicle_data_res);
                    $all_route = [];
                    if(!empty($r_route_data_res)){
                       foreach ($r_route_data_res as $route_val) {
                        
                          $all_route[] = $route_val->id;
                       }
                    }

                    
                    if(!empty($aData['vehicle_types'])){
                       foreach ($aData['vehicle_types'] as $type_val) {
                          
                          $aSeach['type_id'] = $type_val->id;
                          $r_vehicle_data_res_type = VehicleModel::get_all_vehicles_subtype($aSeach);
                          
                          $all_vehicle_subtypes = [];
                            if(!empty($r_vehicle_data_res_type)){
                               foreach ($r_vehicle_data_res_type as $subtype_val) {
                                
                                  $all_vehicle_subtypes[] = $subtype_val->id;

                                
                               }
                            } 

                            if(!empty($all_route) && !empty($all_vehicle_subtypes)){
                               // echo '<pre>';print_r($all_vehicles);

                               // echo '<pre>';print_r($all_vehicle_subtypes);
                               // echo '<pre>';print_r($aSeach['type_id']);

                                $sql = 'SELECT pockets,type FROM daily_route_details WHERE current_day='.$i_current_date.' AND route_id in ('.implode(',',$all_route).' ) AND type in ('.implode(',',$all_vehicle_subtypes).' )';
                                //echo $sql.'<br>';
                                $Result = DB::select($sql);

                                //echo '<pre>';print_r($Result);

                                if(!empty($Result)){
                                   
                                    foreach($Result as $temp){

                                        
                                        
                                        if($temp->pockets != NULL){
                                            $pocket_data = json_decode($temp->pockets,true);
                                        //echo '<pre>';print_r($pocket_data);
                                            $allValuesOne = 0;
                                            
                                            if(!empty($pocket_data)){
                                                foreach($pocket_data as $pocket){

                                                    $allValuesOne += $pocket['is_present'];
                                                  
                                                }
                                             //echo '<pre>';print_r($allValuesOne);

                                                if ($allValuesOne) {
                                                   $daily_vehicle_att_pre_tot += 1;
                                                } 
                                            }

                                        }
                                        
                                    }
                                } 
                            }
                          
                       }
                    }
                }
            }

        $aData['vehicle_count'] =  ['present_count' => $daily_vehicle_att_pre_tot,'total_count' => $veh_total];

       /* end */

       //echo '<pre>';print_r($daily_vehicle_att);
        //die;

        $aData['package_id']    = $package_id;
        $aData['pakages_all']   = VehicleModel::get_Pakages()->orderBy('Pakage_name', 'ASC')->get();

        return view('home.user_dashboard', $aData);
    }
    public function get_dashboard_data(Request $request){

        if(!empty($request->user_dashbord) && $request->user_dashbord == 'user_dashbord'){
              
              $response = array();

              $aData['txt_date']          = $request->txt_date;
              $aData['Pakage_id']         = $request->Pakage_id;
              $accordion_flag             = ($request->accordion_flag)?$request->accordion_flag:'';
              $accordion_icon_val         = ($request->accordion_icon_val)?$request->accordion_icon_val:'';
              $accordion_flag_id          = ($request->accordion_flag_id)?$request->accordion_flag_id:'';

              $r_records = VehicleTrakingReportModel::get_all_vehicle_track_data($aData);

              // echo '<pre>';print_r($r_records);die;
              
              

              $html = '';

              $total_distance_all = 0;
              $done_distance_all  = 0;
              $total_passes_all   = 0;
              $done_passes_all    = 0;
              $total_time_all     = 0;

              $i_no = 0;
              $response2 = array();

              

              if(!empty($r_records)){

                //echo '<pre>';print_r($r_records);

            $html .= '<div class="accordion" id="accordionExample">';
              
              foreach ($r_records as $value) {
                  //echo'<pre>';print_r($value);
              $i_no++;

                 $status_active = '';

                if($accordion_flag !='' && $i_no == $accordion_flag_id){
                   
                    $status_active = $accordion_flag; 
                }

                $status_acco_icon = '';

                if($accordion_icon_val !='' && $i_no == $accordion_flag_id){
                   
                    $status_acco_icon = $accordion_icon_val; 
                }

                if (strlen($value->route_name) > 20){ 
                    
                    $route_name = substr($value->route_name, 0, 20) . '...'; 
                          
                }else{

                   $route_name = $value->route_name;  
                }

                $html .= '<div class="card">
                            <div class="card-header py-2 cursor-pointer" style="background-color: #4f46ba; border-radius: 5px;" id="heading'.$i_no.'" data-toggle="collapse" data-target="#collapse'.$i_no.'" aria-expanded="false" aria-controls="collapse'.$i_no.'>
                               <div class="row w-100" onclick="collapse_name('.$i_no.')">
                               <div class="col-sm-4 d-flex align-items-center">
                                  <img src="' . asset('assets/img/road-cleaning-machine.png') . '" alt="" style="width: 50px;" class="mr-1">
                                  <div>
                                      <div class="d-flex align-items-center mb-1">
                                        <h2 class="content-header-title float-left mb-0 text-light" data-toggle="collapse" data-target="#collapse'.$i_no.'" aria-expanded="false" aria-controls="collapse'.$i_no.'">'.$value->vehicle_number.'
                                          </h2>   
                                           <h4 class="content-header-title float-left mb-0 text-light" data-toggle="collapse" data-target="#collapse'.$i_no.'" aria-expanded="false" aria-controls="collapse'.$i_no.'">'.$value->type.' 
                                          </h4>  
                                          <h5 class="m-0"><div class="circle pulse" id="collapse_color'.$i_no.'"></div></h5>
                                      </div>  
                                      <div>
                                          <h4 class="content-header-title mb-0 text-light" title="'.$value->route_name.'">Route name :  '.$route_name.' 
                                          </h4>  
                                      </div>
                                  </div>                            
                               </div>
                               <div class="col-sm-2 d-flex align-items-center justify-content-center">
                                    <div class="avatar bg-light-info me-2" style="height: fit-content;">
                                       <div class="avatar-content">
                                          <i class="fa fa-clock-o" aria-hidden="true" style="font-size: 20px;"></i>
                                       </div>
                                 </div>
                                    <div class="my-auto px-1">
                                        <h4 class="fw-bolder text-light">Total Hours</h4>
                                        <h4 class="fw-bolder mb-0 text-light" id="perti_time_tot'.$i_no.'"></h4>
                                    </div>
                                </div>
                                <div class="col-sm-2 d-flex align-items-center justify-content-center">
                                    <div class="avatar bg-light-danger me-2" style="height: fit-content;">
                                        <div class="avatar-content">
                                           <i class="fa fa-map-marker" aria-hidden="true" style="font-size: 20px;"></i>
                                        </div>
                                    </div>
                                    <div class="my-auto px-1">
                                        <h4 class="fw-bolder text-light">Distance (KM)</h4>
                                        <h4 class="fw-bolder mb-0 text-light" id="perti_distance_tot'.$i_no.'"></h4>
                                    </div>
                                </div>
                                <div class="col-sm-2 d-flex align-items-center justify-content-center">
                                    <div class="avatar bg-light-success me-2" style="height: fit-content;">
                                       <div class="avatar-content">
                                         <i class="fa fa-map-o" aria-hidden="true" style="font-size: 20px;"></i>
                                       </div>
                                    </div>
                                    <div class="my-auto px-1">
                                        <h4 class="fw-bolder text-light">Route Coverage</h4>
                                        <h4 class="fw-bolder mb-0 text-light" id="perti_passes_tot'.$i_no.'"></h4>
                                    </div>
                                </div>
                                
                                <div class="col-sm-1 d-flex align-items-center justify-content-end">
                                    <div class="avatar bg-light me-2" style="height: fit-content;">
                                       <div class="avatar-content">
                                        <i class="fa fa-chevron-down text-primary '.$status_acco_icon.'" id="custom-accordion-icon'.$i_no.'" aria-hidden="true"></i>
                                       </div>
                                 </div>
                                    
                                </div>
                            </div>
                            

                        <!-- class="collapse show" -->
                        <div id="collapse'.$i_no.'" class="collapse '.$status_active.'" aria-labelledby="heading'.$i_no.'" data-parent="#accordionExample">
                        <div class="row px-1 py-2">
                        ';
                     
                     
                     if(!empty($value->pockets)){


                        $pocket_data = json_decode($value->pockets,true);

                        $pending_distance_tot_flag = 0;
                        $pending_passes_tot_flag = 0;
                        $manallValueszero_tot = 0;
                        $flag_check_zero = 'false';

                        $perticular_time_total = 0;
                        $perticular_distance_tot = 0;
                        $perticular_done_distance = 0;
                        $perticular_passes_tot = 0;
                        $perticular_passes_done = 0;
                        
                        if(!empty($pocket_data)){
                             //echo '<pre>';print_r($value->pockets);
                        
                        

                        foreach ($pocket_data as $pocket_val) {
                         //echo '<pre>';print_r($pocket_val);


                        $pocket_in = ($pocket_val['pocket_in'])?date('H:i:s',$pocket_val['pocket_in']):'00:00:00';
                        $pocket_out = ($pocket_val['pocket_out'])?date('H:i:s',$pocket_val['pocket_out']):'00:00:00';

                        $total_time_work = gmdate('H:i:s', $pocket_val['pocket_total_time']);

                       $total_distance = (isset($pocket_val['default_distance']))? round($pocket_val['default_distance'],2):'NA';

                        $done_distance = ($pocket_val['distance_travelled'])?round($pocket_val['distance_travelled'] / 1000,2):0;

                        $total_distance1 = 0;
                         
                        if($total_distance != 'NA'){
                           
                          $total_distance1      = $total_distance;
                          $total_distance_all += $total_distance;
                          $perticular_distance_tot += $total_distance;

                          
                        }

                        $pending_distance  = $total_distance1 - $done_distance;

                        $total_passes = $pocket_val['passes'];

                        $done_passes  = $pocket_val['current_pass'];

                        $pending_passes  = $total_passes - $done_passes;
                        
                        $done_distance_all         += $done_distance;
                        $total_passes_all          += $total_passes;
                        $done_passes_all           += $done_passes;
                        $total_time_all            += $pocket_val['pocket_total_time'];
                        $perticular_passes_tot     += $total_passes;
                        $perticular_passes_done    += $done_passes;
                        $perticular_time_total     += $pocket_val['pocket_total_time'];
                        $perticular_done_distance  += $done_distance;

                        $flag_check_zero = 'true';



                        if($pending_distance != 'NA' && $pending_distance <= 0){
                            
                            $img_distance =  asset('assets/img/green-distance.png');
                            
                        }else{

                            $img_distance =  asset('assets/img/red-distance.png');
                        }


                        
                        if($pending_passes == 0){
                            
                            $img_flag =  asset('assets/img/green-flag.png');

                        }else{

                            $img_flag =  asset('assets/img/red-flag.png');
                        }


                        if($pending_distance != 'NA' && $pending_distance <= 0 && $pending_passes == 0){
                         
                           $class_name = 'code-green';

                        }else{

                           $class_name = 'code-red'; 
                        }

                        if($pocket_val['is_present'] == 1){

                           $check_status = '<span class="badge bg-success">Present</span>';
                        }else{
                            $check_status = '<span class="badge bg-danger">Absent</span>';
                        }
                        
                        if($pending_distance <= 0){
                           $pending_distance_tot = 0;
                        }else{
                          $pending_distance_tot = round($pending_distance,2); 
                        }

                        $pending_distance_tot_flag += $pending_distance_tot;
                        $pending_passes_tot_flag += $pending_passes;

                        if (strlen($pocket_val['pocket_name']) > 20){ 
                           $pocket_name = substr($pocket_val['pocket_name'], 0, 20) . '...'; 
                           //echo($new_string . "\n"); 
                        }else{

                           $pocket_name = $pocket_val['pocket_name'];  
                        }

                    $html .='
   <div class="col-sm-3">
      <div class="card-body p-0 py-1">
            <div class="d-flex align-items-center mb-1">
                  <div class="text-center" style="padding-bottom: 5px;">
                     <p class="m-0">'.$check_status.'</p>
                  </div>
            <h4 class="content-header-title float-left m-0 pl-1" title="'.$pocket_val['pocket_name'].'">'.$pocket_name.'</h4>
            
            </div>
            <div class="card mb-0 '.$class_name.'">
            <div class="">
               

               <div class="col-12 col-sm-12 col-md-12 col-lg-12 col-xl-12 col-xxl-12 p-1" style="border-bottom:2px solid #fff">
                    <div class="d-flex justify-content-center align-items-center">
                        
                        <h5 class="badge badge-light text-dark text-center"><i class="fa fa-clock-o" aria-hidden="true"></i> &nbsp Time</h5>
                    </div>                
                  <div class="row justify-content-center">
                      <!-- <div class="col-sm-2 text-center d-flex justify-content-center align-items-center">
                        <img src="'. asset('assets/img/route-name.png') .'" alt="" style="width: 40px;height: fit-content;">
                     </div> -->
                     <div class="col-sm-4 d-flex flex-column justify-content-center align-items-center text-center">
                        <p class="m-0"><strong>'.$total_time_work.'</strong></p>
                        <small class="m-0 font-weight-bold"> Total Time</small>
                     </div>
                     <div class="col-sm-4 d-flex flex-column justify-content-center align-items-center text-center">
                        <p class="m-0"><strong>'.$pocket_in.'</strong></p>
                        <small class="m-0 font-weight-bold">In Time</small>
                     </div>
                     <div class="col-sm-4 d-flex flex-column justify-content-center align-items-center text-center">
                        <p class="m-0"><strong>'.$pocket_out.'</strong></p>
                        <small class="m-0 font-weight-bold">Out Time</small>
                     </div>
                  </div>
               </div>
               <div class="col-12 col-sm-12 col-md-12 col-lg-12 col-xl-12 col-xxl-12 p-1" style="border-bottom:2px solid #fff">
                   <div class="d-flex justify-content-center align-items-center">
                       
                        <h5 class="badge badge-light text-dark text-center"><i class="fa fa-map-marker" aria-hidden="true"></i> &nbsp Distance</h5>
                    </div>  
                  <div class="row justify-content-center">
                    <!-- <div class="col-sm-2 text-center d-flex justify-content-center align-items-center">
                        <img src="'. $img_distance .'" alt="" style="width: 40px;height: fit-content;">
                     </div>-->
                     <div class="col-sm-4 d-flex flex-column justify-content-center align-items-center text-center">
                        <p class="m-0"><strong>'.$total_distance.'</strong></p>
                        <small class="m-0 font-weight-bold">Total Km</small>
                     </div>
                     <div class="col-sm-4 d-flex flex-column justify-content-center align-items-center text-center">
                        <p class="m-0"><strong>'.$done_distance.'</strong></p>
                        <small class="m-0 font-weight-bold">Completed Km</small>
                     </div>
                     <div class="col-sm-4 d-flex flex-column justify-content-center align-items-center text-center">
                        <p class="m-0"><strong>'. $pending_distance_tot .'</strong></p>
                        <small class="m-0 font-weight-bold">Pending Km</small>
                     </div>
                  </div>
               </div>
               <div class="col-12 col-sm-12 col-md-12 col-lg-12 col-xl-12 col-xxl-12 p-1">
                      <div class="d-flex justify-content-center align-items-center">
                        
                        <h5 class="badge badge-light text-dark text-center"><i class="fa fa-flag" aria-hidden="true"></i> &nbsp Passes</h5>
                    </div>  
                  <div class="row justify-content-center">
                     <!-- <div class="col-sm-2 text-center d-flex justify-content-center align-items-center">
                        <img src="'. $img_flag .'" alt="" style="width: 40px;height: fit-content;">
                     </div> -->
                     <div class="col-sm-4 d-flex flex-column justify-content-center align-items-center text-center">
                        <p class="m-0"><strong>'.$total_passes.'</strong></p>
                        <small class="m-0 font-weight-bold">Total Passes</small>
                     </div>
                     <div class="col-sm-4 d-flex flex-column justify-content-center align-items-center text-center">
                        <p class="m-0"><strong>'.$done_passes.'</strong></p>
                        <small class="m-0 font-weight-bold">Completed Passes</small>
                     </div>
                     <div class="col-sm-4 d-flex flex-column justify-content-center align-items-center text-center">
                        <p class="m-0"><strong>'.$pending_passes.'</strong></p>
                        <small class="m-0 font-weight-bold">Pending Passes</small>
                     </div>
                  </div>
               </div>
            </div>
            </div>
      </div>
   </div>
   
';
                           
                          }

                        }

                        if ($pending_distance_tot_flag == 0 && $pending_passes_tot_flag == 0 && $flag_check_zero == 'true') {
                               $manallValueszero_tot = 1;
                           }

                          // echo $pending_passes_tot_flag.'<br>';

                           


                        $perti_passes_tot = 0;
                        if($perticular_passes_tot){

                           $perti_passes_tot = round(($perticular_passes_done/$perticular_passes_tot)*100,2);
                        }

                        if($perticular_done_distance !=0){
                           $perti_distance_tot = $perticular_done_distance.' / '.$perticular_distance_tot;
                        }else{
                            $perti_distance_tot = '0 / 0';
                        }

                        $response3[] = array(
                                             'i_no' => $i_no,
                                             'perti_passes_tot' => $perti_passes_tot.' %',
                                             'perti_distance_tot' => $perti_distance_tot,
                                             'perti_time_tot' => gmdate('H:i:s',$perticular_time_total),
                                             'collapse_color' => $manallValueszero_tot
                                            );

                         $response['perti_tot_all']   = $response3;
                    }

                $html .='</div></div></div>';
              }
              $html .='<div><input type="hidden" name="i_no" id="i_no" value="'.$i_no.'"></div>';
              $html .='</div>';
            }else{
             
             $html .='<div class="card d-flex justify-content-center align-items-center" style="height: calc(100vh - 300px);">
                    <div class="d-flex justify text-center-content-center align-items-center flex-column">
                       <img src="'. asset('assets/img/noRecordFound.png') .'" class="pt-1" alt="Record Not Found" style="width: 200px;" />
                        <h2 class="fw-bolder mb-1">Vehicle Record Not Found!</h2>
                    </div>
                 </div>';
            } 

          
            $total_passes_per = 0;
            if($total_passes_all){

               $total_passes_per = round(($done_passes_all/$total_passes_all)*100,2);
            }
             
            if($done_distance_all !=0){
               $response['total_distance_all'] = $done_distance_all.' / '.$total_distance_all;
            }else{
                $response['total_distance_all'] = '0 / 0';
            }

            
            $response['html'] = $html;
            $response['total_passes_per']   = $total_passes_per.' %';
            $response['total_time_all']     = gmdate('H:i:s',$total_time_all);
            $response['accordion_flag']     = $accordion_flag;
            $response['accordion_flag_id']     = $accordion_flag_id;

            //echo '<pre>';print_r($response);

            return json_encode($response);   
        }

    }

    public function get_checkpoints(Request $request){
        $aData['track_checkpoint'] = HomeModel::get_daily_checkpoints();
        return view('home.ajax_checkpoint', $aData);
    }

    public function admin_dashboard_details(Request $request){
        $aData = array();
        
        $aData['aPakage'] = PakageModel::get_Pakages()->get();
        $aData['designation'] = DesignationModel::get_designation()->get();

        $aData['txt_date'] = (!empty(session('current_day'))) ? session('current_day') : date('d-m-Y');


        foreach ($aData['aPakage'] as $aPakage_val) {
            
        /* Manpower Attendance */

            $aData['emp_data'][$aPakage_val->id] = [];

            $all_designation = [];
            if(!empty($aData['designation'])){
               foreach ($aData['designation'] as $des_val) {
                
                  $all_designation[] = $des_val->id;
               }
            }

            //echo '<pre>';print_r($all_designation);die();
            
            $sql = 'SELECT count(bu.id) as total_count,bu.Pakage_id,bu.designation,SUM(CASE WHEN ua.success = 1 THEN 1 ELSE 0 END) AS present_count FROM biometric_users bu LEFT JOIN users_attendance ua ON ua.user_id=bu.id AND ua.Pakage_id=bu.Pakage_id WHERE bu.is_active=1 AND ua.attendance_date='.strtotime($aData['txt_date']).' AND bu.Pakage_id='.$aPakage_val->id.' AND designation in ('.implode(',',$all_designation).' ) GROUP BY designation';
                //echo '<br>'.$sql.'<br>';
                $Result = DB::select($sql);

                if(!empty($Result)){
                    foreach($Result as $val){

                        $aData['emp_data'][$aPakage_val->id][$val->designation]['present'] = $val->present_count;
                    }
                }
            
        


        /* Vehicle Attendance */

        $i_current_date = date('Ymd',strtotime($aData['txt_date']));
       // echo $i_current_date;die;
        
        $aData['vehicle_types'] = VehicleModel::get_vehicle_types();
        //echo '<pre>';print_r($data['vehicle_types']);die;

            $aData['daily_vehicle_att'][$aPakage_val->id] = [];
            $aSeach['packege_id'] = $aPakage_val->id;
            $r_route_data_res = RouteModel::get_to_fetch_route($aSeach);
            //echo '<pre>';print_r($r_vehicle_data_res);
            $all_route = [];
            if(!empty($r_route_data_res)){
               foreach ($r_route_data_res as $route_val) {
                
                  $all_route[] = $route_val->id;
               }
            }

            
            if(!empty($aData['vehicle_types'])){
               foreach ($aData['vehicle_types'] as $type_val) {
                  
                  $aSeach['type_id'] = $type_val->id;
                  $r_vehicle_data_res_type = VehicleModel::get_all_vehicles_subtype($aSeach);
                  
                  $all_vehicle_subtypes = [];
                    if(!empty($r_vehicle_data_res_type)){
                       foreach ($r_vehicle_data_res_type as $subtype_val) {
                        
                          $all_vehicle_subtypes[] = $subtype_val->id;

                        
                       }
                    } 

                    if(!empty($all_route) && !empty($all_vehicle_subtypes)){
                       
                        $sql = 'SELECT pockets,type FROM daily_route_details WHERE current_day='.$i_current_date.' AND route_id in ('.implode(',',$all_route).' ) AND type in ('.implode(',',$all_vehicle_subtypes).' )';
                        //echo $sql.'<br>';
                        $Result = DB::select($sql);

                        //echo '<pre>';print_r($Result);

                        if(!empty($Result)){
                           
                            foreach($Result as $temp){
                                if(!isset($aData['daily_vehicle_att'][$aPakage_val->id][$type_val->id])){
                                    $aData['daily_vehicle_att'][$aPakage_val->id][$type_val->id] = 0;
                                }
                                if($temp->pockets != NULL){
                                    $pocket_data = json_decode($temp->pockets,true);
                                //echo '<pre>';print_r($pocket_data);
                                    $allValuesOne = 0;
                                    
                                    if(!empty($pocket_data)){
                                        foreach($pocket_data as $pocket){

                                            $allValuesOne += $pocket['is_present'];
                                          
                                        }
                                     //echo '<pre>';print_r($allValuesOne);

                                        if ($allValuesOne) {
                                           $aData['daily_vehicle_att'][$aPakage_val->id][$type_val->id] += 1;
                                        } 
                                    }

                                }
                                
                            }
                        } 
                    }
                  
               }
            }
        


        /* Area Coverage */
        
           
          $aData['Pakage_id'] = $aPakage_val->id; 

          $aData['area_coverage'][$aPakage_val->id] = [];
          $records = VehicleTrakingReportModel::get_all_vehicle_track_data($aData);
            
            $required_passes = 0;
            $coverage_passes = 0;
            $distance_travelled = 0;
            $total_time = 0;
            if(!empty($records)){

                $pocket1 = array();
                foreach ($records as $value) {

                    $pocket1 = json_decode($value->pockets);

                    if(!empty($pocket1)){
                        
                        

                        foreach ($pocket1 as $pocket1_val) {

                            $required_passes += $pocket1_val->passes;
                            
                            $coverage_passes += $pocket1_val->current_pass;

                            $distance_travelled += ($pocket1_val->distance_travelled)?round($pocket1_val->distance_travelled/1000,2):0;
                            
                            $total_time += ($pocket1_val->pocket_total_time)?$pocket1_val->pocket_total_time:0;
                       
                              
                        }

                    }
                }
                
            }
            // echo '<br>'.$aPakage_val->id.'<br>';
             //echo '<pre>';print_r($distance_travelled);
            
            $route_covered_per_val = 0;
            if($required_passes){
            $route_covered_per_val = round(($coverage_passes / $required_passes)*100,2); 
            }

            $aData['area_coverage'][$aPakage_val->id] = $route_covered_per_val;


            $distance_travelled_val = 0;
            if($distance_travelled){
            $distance_travelled_val = $distance_travelled; 
            }

            $aData['travel_dis'][$aPakage_val->id] = $distance_travelled_val;


            $total_time_val = 0;
            if($total_time){
            $total_time_val = $total_time; 
            }

            $aData['total_time'][$aPakage_val->id] = $total_time_val;

           //echo $distance_travelled_val;
        }
        
        //echo '<pre>';print_r($aData['total_time']); 
        //die();

        

        return view('home.admin_dashboard', $aData);
    }        
    public function get_wards(Request $request)
    {
        $aWards = WardModel::where('Pakage_id',$request->Pakage_id)->get();
        $assigWards = WardModel::where('id',$request->ward_id)
                                ->where('Pakage_id',$request->Pakage_id)
                                ->select('ward_no')->first();
        $userWards = array();
        if(isset($assigWards->ward_no)){
            $userWards = explode(',',$assigWards->ward_no);
        }
        
        $html = '';
        $html .= '<option value="0">--- Select Wards ---</option>';  
        foreach($aWards as $val){
            $selected = '';           
            if(in_array($val->id,$userWards)){
                $selected = 'selected';
            } 
          
            $html .= '<option '.$selected.' value="'.$val->id.'">'.$val->ward_name.'</option>';
        }
        return $html;
    }
    public function get_to_change_current_date(Request $request)
    {
        Session::put('current_day',$request->current_date);
    }
}

