<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\SupervisorModel;
use App\Libraries\Mysecurity;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\DB;

class SupervisorMapController extends Controller
{   
    public function __construct()
    {
        $module_link = request()->segments(0);
        if(isset($module_link[0])){
            $module_link = $module_link[0];
            $this->mysecurity = new Mysecurity();
            $this->module_id = $this->mysecurity->get_module_id_by_name($module_link);
            $this->middleware(function ($request, $next){
                $this->mysecurity->check_access(Session::get('logged_in')['id'],$this->module_id,1);
        
                return $next($request);
            });
        }
    }
    
    public function clear_search(){
        session::forget('date');
        session::forget('supervisor_id');
        return redirect()->route('supervisor_map.index');
    }

    public function index(Request $request)
    {  
        $this->mysecurity->check_access(Session::get('logged_in')['id'],$this->module_id,2);
        $aData = array();

        if($request->form_type=='search_form'){ 
            session::put(['supervisor_id'  => $request->supervisor_id]);
            session::put(['date'           => $request->date]);
        }
        
        $aData['supervisor_id'] = session::has('supervisor_id') ? session::get('supervisor_id') : '';
        $aData['date']       = session::has('date') ? session::get('date') : date('d-m-Y',strtotime('now'));
    
        if(!empty($aData['supervisor_id']) || !empty($aData['date'])){
            $aData['search'] = 1;
        }
        
        $aData['supervisor_details']   = SupervisorModel::get_supervisor()->orderBy('supervisor_name', 'ASC')->get();
        $aData['result'] = SupervisorModel::get_map_lacations($aData);
        return view('supervisor_map.supervisor_map_location',$aData);
    }

    public function search(Request $request){

        session(['supervisor_id'  => $request->supervisor_id]);
        session(['date'           => $request->date]);
        return redirect()->route('supervisor_map.index');
        
    }

    public function supervisor_route_map(Request $request){
       // dd($request->id);
       $supervisor_id = $request->id;
       $date = $request->date;
       $aData['rRoute'] = SupervisorModel::get_route_map($supervisor_id,$date);
       $aData['rAssignPraghabBoundary'] = SupervisorModel::get_assign_prabhag_boundary($supervisor_id);
       
      // print_r($aData['rAssignPraghabBoundary']); die;
       if(!empty($supervisor_id)){
           $aData['supervisor_details'] = SupervisorModel::get_supervisor_name($supervisor_id);
       }
       return view('supervisor_map.supervisor_route_map',$aData);
    }

}

