<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\DB;


class AdminUserRight extends Model
{
    use HasFactory;
    protected $table = 'admin_user_rights';


    public $timestamps = false;
    protected $fillable = [
        'user_id',
        'module_id',
        'access'
    ];

    public static function get_user_modules($user_id,$iIsSuperadmin){
        if($iIsSuperadmin){
            $rAccess = DB::table('admin_modules')
                        ->select('id as module_id')
                        ->where('active','=',1)
                        ->where('id','!=',23)
                        ->orderBy('sort_order', 'ASC')
                        ->get();
        }else{
            
            $rAccess = DB::table('admin_modules')
                        ->leftJoin('admin_user_rights', 'admin_modules.id', '=', 'admin_user_rights.module_id')
                        ->select('admin_modules.id as module_id')
                        ->where('admin_user_rights.user_id','=',$user_id)
                        ->where('admin_user_rights.access','>',0)
                        ->where('admin_modules.active','=',1)
                        ->orderBy('admin_modules.sort_order', 'ASC')
                        ->get();
        }
		$aReturn = array();
       
		foreach($rAccess as $aAccess){
            $rModule = DB::table('admin_modules')->select('id','module_name','module_link','module_fa_icon')->where('id','=',$aAccess->module_id)->first();            
            $rModule = json_decode(json_encode($rModule,true),true);            
			$aReturn[$rModule['module_name']] = $rModule;
		}
		return $aReturn;
    }

    public static function get_user_Pakages($iID,$iIsAdmin){
        $aReturn = array();
        if(!$iIsAdmin){
            $rAccess = 'SELECT Pakage_id FROM user_Pakages where user_id ='.$iID;
            $rRes = DB::select( DB::raw($rAccess));	

            foreach($rRes as $aDivisio){
                $aReturn[] = $aDivisio->Pakage_id;
            }
        }
       return $aReturn;
    }

    public static function get_user_dashboard_access($iID,$iIsUser){
        $result = array();
        if($iIsUser == 0){
            $uAccess = 'SELECT count(id) as access_count FROM admin_user_rights where user_id ='.$iID.' AND module_id = 23 AND access != 0';
            $result = DB::select( DB::raw($uAccess)); 
        }
       return $result;
    }
}
