<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Session;

class VehicleRoute extends Model
{
    use HasFactory;
    protected $table = 'vehicle_routes';

    protected $fillable = [
        'route_id',
        'type',
        'vehicle_number',
        'day'
    ];

    public $timestamps = false;

    public static function get($aSearch){
        //$aSearch = '';
        //echo $aSearch['day'];die;
        $query = VehicleRoute::from('vehicle_routes as vr')
                                    ->leftJoin('route_master as rm','vr.route_id', '=','rm.id')
                                    ->leftJoin('vehicle_master as vm','vr.vehicle_number', '=','vm.id')
                                    ->leftJoin('vehicle_subtypes as vs','vs.id', '=','vr.type')
                                    ->leftJoin('vehicle_types as vt','vt.id', '=','vs.vehicle_type_id')
                                    ->leftJoin('master_days as md','vr.day', '=','md.id')
                                    ->select('vr.*','rm.route_name', 'vm.vehicle_number',DB::raw("concat(vs.name,'(',vt.type,')') as type"),'md.day');
                                    if($aSearch['vehicle_number'] > 0){
                                        $query->where('vm.vehicle_number',$aSearch['vehicle_number']);
                                    }
                                    
                                    if($aSearch['Pakage_id'] > 0){
                                        $query->where('vm.Pakage_id',$aSearch['Pakage_id']);
                                    }
                                    if($aSearch['ward_id'] > 0){
                                        $query->where('rm.ward_id',$aSearch['ward_id']);
                                    }
                                    if ($aSearch['day']) {
                                        $query->where('vr.day', $aSearch['day']);
                                    }
                                    if ($aSearch['route_id']) {
                                        $query->where('vr.route_id', $aSearch['route_id']);
                                    }
                                    
                
                                    if(Session::has('logged_in.superuser') && Session::get('logged_in.superuser') !=1){
                                        $session_div = Session::get('Pakages'); 
                                        if(!empty($session_div)){
                                            $query->whereIn('rm.Pakage_id',$session_div);    
                                        }else {
                                            $query->whereRaw('1=2');   
                                        }
                                    }                          

        return $query;
    }

    public static function get_route(){
       
        $query = DB::table('route_master')->select('*');           
        if(Session::has('logged_in.superuser') && Session::get('logged_in.superuser') !=1){
            $session_div = Session::get('Pakages'); 
            if(!empty($session_div)){
                $query->whereIn('Pakage_id',$session_div);    
            }else {
                $query->whereRaw('1=2');   
            }
        }
        return $query;
    }


    

    public static function update_route_id($route_id,$vehicle_id){

        $current_date = date('Ymd');
        $update_sql = 'update daily_route_details set route_id = '.$route_id.' where vehicle_number = '.$vehicle_id.' and current_day = '.$current_date.' ';
        //echo $update_sql; die;
        $result2 = DB::update(DB::raw($update_sql));
    }

}
