<?php

// use Illuminate\Support\Facades\Facade;

return [
    'base_url' => env('APP_URL'),

    'google_map_key' =>  env('GOOGLE_API_KEY'),

    'module_sort_order' => array(
        '1' => 1,
        '2' => 2,
        '3' => 3,
        '4' => 4,
        '5' => 5,
        '6' => 6,
        '7' => 7,
        '8' => 8,
        '9' => 9,
        '10' => 10,
        '11' => 11,
        '12' => 12,
        '13' => 13,
        '14' => 14,
        '15' => 15
    ),

    'checkpoint_numbers' => array(
        '1' => 1,
        '2' => 2,
        '3' => 3,
        '4' => 4,
        '5' => 5,
        '6' => 6,
        '7' => 7,
        '8' => 8,
        '9' => 9,
        '10' => 10
    ),

    'divColors' => array(
        1 => '#3c3cad',
        2 => '#995c1d',
        3 => '#2cc960',
        4 => '#ba51ad',
       // 5 => '#00382b',
        5 => '#1f9176',
        6 => '#03689b',
        7 => '#89ab0d',
    ),

    'max_color_count' => 11,

    'routeColors' => array(
        '#a00000',
        '#03689b',
        '#aa008e',
        '#7a79b7',
        '#2cc960',
        '#1d7f18',
        '#5c5c63',
        '#49a2fc',
        '#ba51ad',
        '#3c3cad',
        '#a020e5',
        '#dd6a40',
    ),

    'update_time_limit' => '-30 minutes',
    'page_limit' => 30,

    'aTime_intervals' => array(
        1 => array(
            'min' => '0',
            'max' => '15',
            'last' => 0,
            'text' => '00 to 15 Minutes'
        ),
        2 => array(
            'min' => '15',
            'max' => '30',
            'last' => 0,
            'text' => '>15 to <30 Minutes'
        ),
        3 => array(
            'min' => '30',
            'max' => '60',
            'last' => 0,
            'text' => '>30 to <60 Minutes'
        ),
        4 => array(
            'min' => '60',
            'max' => '120',
            'last' => 0,
            'text' => '>60 to <120 Minutes'
        ),
        5 => array(
            'min' => '120',
            'max' => 'Unlimited, So Last is 1',
            'last' => 1,
            'text' => '>120 Minutes'
        )
    ),

    /* ROUTE DEVIATION FINE FOR PERCENTAGE SLICE - PER DAY, PER VEHICLE  */
    'deviation_fine' => array(
        '95_to_100' => 0,
        '90_to_94' => 100,
        '80_to_89' => 150,
        '70_to_79' => 200,
        '60_to_69' => 250,
        '50_to_59' => 500,
        'less_than_50' => 1000,
    ),

    /* ROUTE DEVIATION FINE WILL BE APPLICABLE FROM 1ST JULY OF 2019 */
    'deviation_fine_start_day_ymd' => '20190701',

    'months' => array(
        '1' => 'Jan',
        '2' => 'Feb',
        '3' => 'Mar',
        '4' => 'Apr',
        '5' => 'May',
        '6' => 'Jun',
        '7' => 'Jul',
        '8' => 'Aug',
        '9' => 'Sep',
        '10' => 'Oct',
        '11' => 'Nov',
        '12' => 'Dec',
    ),
    
    'year' => array(
        '2016' => '2016',
        '2017' => '2017',
        '2018' => '2018',
        '2019' => '2019',
        '2020' => '2020',
        '2021' => '2021',
        '2022' => '2022',
        '2023' => '2023',
        '2024' => '2024',
        '2025' => '2025',
        '2026' => '2026',
        '2027' => '2027',
        '2028' => '2028',
        '2029' => '2029',
        '2030' => '2030'
    ),

    'checkpoints_fine' => 1000,
    'absent_fine'      => 10000,
    'employeeFine'     => 100,
    'track_chkpts_seconds_limit' => 1800,
  
    // emp_data_total Attendance Report first array kay is master package id and second array key master designation id by monu 19-12-2023

    'emp_data_total' => array(
        '2'=> array(
                '1'=> array(
                'total' => '32'
               ),
                '2'=> array(
                'total' => '9'
               ),
                '3'=> array(
                'total' => '10'
               ),
                '4'=> array(
                'total' => '4'
               )
        ),
        '3'=> array(
                '1'=> array(
                'total' => '32'
               ),
                '2'=> array(
                'total' => '9'
               ),
                '3'=> array(
                'total' => '10'
               ),
                '4'=> array(
                'total' => '4'
               )
        ),
        '4'=> array(
                '1'=> array(
                'total' => '32'
               ),
                '2'=> array(
                'total' => '9'
               ),
                '3'=> array(
                'total' => '10'
               ),
                '4'=> array(
                'total' => '4'
               )
        ),
        '5'=> array(
                '1'=> array(
                'total' => '32'
               ),
                '2'=> array(
                'total' => '9'
               ),
                '3'=> array(
                'total' => '10'
               ),
                '4'=> array(
                'total' => '4'
               )
        )
    ),
    // vehicle_att_data_total Vehicle Attendance Report first array kay is master package id and second array key vehicle types id by monu 19-12-2023

    'vehicle_att_data_total' => array(
        '2'=> array(
                '1'=> array(
                'total' => '2'
               ),
                '2'=> array(
                'total' => '2'
               ),
                '3'=> array(
                'total' => '4'
               ),
                '4'=> array(
                'total' => '2'
               ),
                '5'=> array(
                'total' => '1'
               )
        ),
        '3'=> array(
                '1'=> array(
                'total' => '2'
               ),
                '2'=> array(
                'total' => '2'
               ),
                '3'=> array(
                'total' => '4'
               ),
                '4'=> array(
                'total' => '2'
               ),
                '5'=> array(
                'total' => '1'
               )
        ),
        '4'=> array(
                '1'=> array(
                'total' => '2'
               ),
                '2'=> array(
                'total' => '2'
               ),
                '3'=> array(
                'total' => '4'
               ),
                '4'=> array(
                'total' => '2'
               ),
                '5'=> array(
                'total' => '1'
               )
        ),
        '5'=> array(
                '1'=> array(
                'total' => '2'
               ),
                '2'=> array(
                'total' => '2'
               ),
                '3'=> array(
                'total' => '4'
               ),
                '4'=> array(
                'total' => '2'
               ),
                '5'=> array(
                'total' => '1'
               )
        )
    ),

    // work start time default Payable Amount Report by monu 30-01-2024

    'work_start_time_default' => array(
        '1'=>'23:00:00',
        '2'=>'23:00:00',
        '3'=>'23:00:00',
        '4'=>'23:00:00',
        '5'=>'23:00:00',
        '6'=>'23:00:00',
        '7'=>'09:00:00',
        '8'=>'23:00:00',
        '9'=>'23:00:00'
        
    ),

    // use to current date by monu 02-01-2024

    'txt_date' => date('d-m-Y'),

    // Payable Amount Report by monu 30-01-2024
    
    'let_by_minut' => '30',

    'less_working_penalty' => '08:00:00',

    'route_coverage_penalty_default'=> array(
                '95_above'=>0,
                '85_to_95'=>100,
                '75_to_85'=>200,
                '75_below'=>500
               ),
    // end

];