<?php

date_default_timezone_set("Asia/Kolkata");
ini_set('display_errors', 1);
error_reporting(E_ALL);
//include("/var/www/html/malegaon_streetlamp/listner/config.php");
//include("/home/vehicle/public_html/config.php");
include("config.php");
//include("/var/www/html/vehicle_tracking/config.php");
//require_once($root_folder."geometrylibrary/MathUtil.php");
//require_once($root_folder."geometrylibrary/PolyUtil.php");
//require_once($root_folder."geometrylibrary/SphericalUtil.php");
require_once($root_folder."/public/geometrylibrary/MathUtil.php");
require_once($root_folder."/public/geometrylibrary/PolyUtil.php");
require_once($root_folder."/public/geometrylibrary/SphericalUtil.php");

function distanceCalculation($point1_lat, $point1_long, $point2_lat, $point2_long) 
{   
    $degrees = rad2deg(acos((sin(deg2rad($point1_lat))*sin(deg2rad($point2_lat))) + (cos(deg2rad($point1_lat))*cos(deg2rad($point2_lat))*cos(deg2rad($point1_long-$point2_long)))));
    $distance = ($degrees * 111.13384)*1000;        
    //echo $distance;die;
    return $distance;
}


function is_polygon_entered($lat,$lng,$time,$old_lat,$old_long,$polygon){
   
    $currentLocationPoints =  array('lat' =>$lat, 'lng' => $lng); 
    $new_point =  \GeometryLibrary\PolyUtil::containsLocation( 
          $currentLocationPoints,$polygon) ;
          
    $oldLocation =  array('lat' =>$old_lat, 'lng' => $old_long); 
    $old_point =  \GeometryLibrary\PolyUtil::containsLocation( 
    $oldLocation,$polygon) ;
    //echo '<br>old_point'.$old_point;
    //echo '<br>new_point'.$new_point;
    
    if(!$old_point && $new_point){
        return true;
        
    }else{
        
            return false;
    }
    
}

function is_polygon_exited($lat,$lng,$time,$vehicle_id,$old_lat,$old_long,$polygon,$root_path){
   
    $currentLocationPoints =  array('lat' =>$lat, 'lng' => $lng); 
    $new_point =  \GeometryLibrary\PolyUtil::containsLocation( 
          $currentLocationPoints,$polygon) ;
          
    $oldLocation =  array('lat' =>$old_lat, 'lng' => $old_long); 
    $old_point =  \GeometryLibrary\PolyUtil::containsLocation( 
    $oldLocation,$polygon) ;
    
    if($old_point && !$new_point){
        
        $today = date('Ymd',$time);
        $folder_path = $root_path.'public/vehicle_exit_log/'.$today;
        $file_path = $folder_path.'/'.$vehicle_id.'.json';
        if(!is_dir($folder_path)){
            $oldmask = umask(0);
            mkdir($folder_path,0777);
            umask($oldmask);
        }
        $data['time'] = $time;
        $data['lat'] = $lat;
        $data['lng'] = $lng;
        
        file_put_contents($file_path,json_encode($data));
        return true;
        
    }else{
        
            return false;
    }
    
}


function convert_time_to_timestamp($strtime){
        $year = substr($strtime,0,4);
        $month = substr($strtime,4,2);
        $day = substr($strtime,6,2);
        $hour = substr($strtime,8,2);
        $minute = substr($strtime,10,2);
        $seconds = substr($strtime,12,2);
        $date = $day.'-'.$month.'-'.$year.' '.$hour.':'.$minute.':'.$seconds;
        $timestamp = strtotime($date);
        //$timestamp = strtotime('+330 minutes',$timestamp);
        return $timestamp;
}

function process_data($connection,$root_folder,$aVehicle,$VehicleMaster){
    //print_r($aVehicle);
    //echo '<br>========================Packet started =================================================<br>';
    $VehicleMaster['vehicle_type'] = (!empty($VehicleMaster['vehicle_type'])) ? $VehicleMaster['vehicle_type'] : 0;
    //$VehicleMaster['route_id'] = (!empty($VehicleMaster['route_id'])) ? $VehicleMaster['route_id'] : 0;
    $lat = $aVehicle['Latitude'];
    $lng = $aVehicle['Longitude'];
    $speed = $aVehicle['Speed'];
    $gpsinfo = $aVehicle['GpsInfo'];
    $sat_quantity = $aVehicle['SatQuantity'];
    
    //$now = strtotime('now');
    $time = strtotime($aVehicle['Datetime']);
    $today = date('Ymd',$time);
    $str_date_time = date('Y-m-d h:i:s',$time);
    //echo date('H',$time);die;
    $dayofweek = date('w', $time)+1;
    // if(date('H',$time) >= 21){
    //     $today = date('Ymd',strtotime('+1 day',$time));
    //     $dayofweek = date('w', $time)+2;
    // }

    if(date('H',$time) <= 6){
        $today = date('Ymd',strtotime('-1 day',$time));
        $dayofweek = date('w', $time);
    }

    $log_file = $root_folder.'/device/cron_log.txt';
    if(!empty($lat) && !empty($lng)  && preg_match('/^[-]?(([0-8]?[0-9])\.(\d+))|(90(\.0+)?)$/',$lat) && preg_match('/^[-]?((((1[0-7][0-9])|([0-9]?[0-9]))\.(\d+))|180(\.0+)?)$/',$lng)){
        $aLatest = array();
        $allPockets =  array();
        //Get route id for the day when data is received
        $sql = 'SELECT id as route_id,start_date,repeat_how_many_days,sub_type_id FROM route_master WHERE vehicle_id = '.$VehicleMaster['vehicle_id'];
        
        $res = mysqli_query($connection,$sql) or die(mysqli_error($connection));
        $VehicleMaster['vehicle_type'] = 0;
        while($aRoute = mysqli_fetch_assoc($res)){
            if((($today - $aRoute['start_date']) % $aRoute['repeat_how_many_days']) == 0){
                $VehicleMaster['route_id'] = $aRoute['route_id'];
                $VehicleMaster['vehicle_type'] = $aRoute['sub_type_id'];
                break;
            }
        }
        
        $VehicleMaster['route_id'] = (isset($VehicleMaster['route_id'])) ? $VehicleMaster['route_id'] : 0;
       
        $sql = 'SELECT latest_latitude,latest_longitude,latest_speed,pockets FROM  daily_route_details drd WHERE route_id='.$VehicleMaster['route_id'].' AND vehicle_number='.$VehicleMaster['vehicle_id'].' AND current_day = '.$today ;
        //echo $sql;
        $res = mysqli_query($connection,$sql) or die(mysqli_error($connection));
        if(mysqli_num_rows($res)){
            while($aData = mysqli_fetch_assoc($res)){
                $aLatest = $aData;
                $allPockets = json_decode($aLatest['pockets'],true);
                $distance_last = distanceCalculation($aLatest['latest_latitude'],$aLatest['latest_longitude'],$lat,$lng);
                if($distance_last > 10000){
                    $distance_last = 0;
                }elseif(is_nan($distance_last)){
                    $distance_last = 0;
                }
                //echo '<pre>';print_r($allPockets);
                foreach($allPockets as $key=>$pockets){
                    
                    if(!$pockets['is_present'])
                    {
                        if(is_point_in_polygon($lat,$lng,$pockets['points'])){
                            $allPockets[$key]['is_present'] = 1;
                            $allPockets[$key]['pocket_in'] = $time;
                            $allPockets[$key]['latest_pocket_in'] = $time;
                            $allPockets[$key]['distance_travelled'] =  $allPockets[$key]['distance_travelled'] + $distance_last;
                            $aChk = check_for_checkpoint($allPockets[$key]['checkpoints'],$lat,$lng,$allPockets[$key]['current_pass'],$allPockets[$key]['passes']);
                            //echo '<pre>';print_r($aChk);
                            if($aChk['point_achived'] != -1){
                                $allPockets[$key]['checkpoints'][$aChk['point_achived']]['passes'] = $allPockets[$key]['current_pass'] + 1;
                                $iSQL = 'INSERT INTO checkpoint_arrival(`checkpoint`,route_id,`date`,`vehicle_number`,`latitude`,`longitude`,`address`,`actual_reach_time`,`distance`,`pass`,polygon_id) VALUES('.$aChk['point_achived'].','.$VehicleMaster['route_id'].','.$today.','.$VehicleMaster['vehicle_id'].','.$lat.','.$lng.',\'\','.$time.','.$aChk['distance'].','.$allPockets[$key]['current_pass'].','.$allPockets[$key]['polygon_id'].')';
                                mysqli_query($connection,$iSQL) or die('insert checkpint error');
                            }
                            //echo '<pre>';print_r($allPockets);
                        }
                    }else{
                        
                        if(is_point_in_polygon($lat,$lng,$pockets['points'])){
                            $aChk = check_for_checkpoint($allPockets[$key]['checkpoints'],$lat,$lng,$allPockets[$key]['current_pass'],$allPockets[$key]['passes']);
                            //echo '<pre>';print_r($aChk);
                            if($aChk['point_achived'] != -1){
                                $allPockets[$key]['checkpoints'][$aChk['point_achived']]['passes'] = $allPockets[$key]['current_pass'] + 1;
                                $iSQL = 'INSERT INTO checkpoint_arrival(`checkpoint`,route_id,`date`,`vehicle_number`,`latitude`,`longitude`,`address`,`actual_reach_time`,`distance`,`pass`,polygon_id) VALUES('.$aChk['point_achived'].','.$VehicleMaster['route_id'].','.$today.','.$VehicleMaster['vehicle_id'].','.$lat.','.$lng.',\'\','.$time.','.$aChk['distance'].','.$allPockets[$key]['current_pass'].','.$allPockets[$key]['polygon_id'].')';
                                mysqli_query($connection,$iSQL) or die('insert checkpint error');
                            }
                            if($aChk['change_pass']){
                                if($allPockets[$key]['current_pass'] < $allPockets[$key]['passes'] ){
                                    $allPockets[$key]['current_pass'] = $allPockets[$key]['current_pass'] + 1;
                                }
                            }
                           
                            $allPockets[$key]['distance_travelled'] =  $allPockets[$key]['distance_travelled'] + $distance_last;
                            $is_in = is_polygon_entered($lat,$lng,$time,$aLatest['latest_latitude'],$aLatest['latest_longitude'],$pockets['points']);
                            if($is_in){
                                $allPockets[$key]['latest_pocket_in'] = $time;
                            }
                        }else{
                            $is_out = is_polygon_exited($lat,$lng,$time,$VehicleMaster['vehicle_id'],$aLatest['latest_latitude'],$aLatest['latest_longitude'],$pockets['points'],$root_folder);
                            if($is_out){
                                $allPockets[$key]['distance_travelled'] =  $allPockets[$key]['distance_travelled'] + $distance_last;    
                                $allPockets[$key]['pocket_out'] = $time;
                                $allPockets[$key]['pocket_total_time'] = $allPockets[$key]['pocket_total_time'] + ($time - $allPockets[$key]['latest_pocket_in']);
                            }
                        }
                    }
                }
                $update_route_id = '';
                if(!empty($VehicleMaster['route_id'])){
                    $update_route_id = ',route_id='.$VehicleMaster['route_id'];
                }
                if(!empty($aLatest)){
                    $sql = 'UPDATE daily_route_details SET pockets=\''.json_encode($allPockets).'\',latest_latitude =  \''.mysqli_real_escape_string($connection,$lat).'\', latest_longitude =  \''.mysqli_real_escape_string($connection,$lng).'\',latest_speed=\''.mysqli_real_escape_string($connection,$speed).'\',latest_time='.$time.',`type`='.$VehicleMaster['vehicle_type'].', distance=distance+'.$distance_last.' '.$update_route_id.'  WHERE current_day='.$today.' AND vehicle_number='.$VehicleMaster['vehicle_id'].' AND route_id='.$VehicleMaster['route_id'].' ';
                    mysqli_query($connection,$sql) or die(1001);
                }
            }
        }else{

            $sSQLchk = 'SELECT * FROM route_polygon_checkpoint WHERE route_id = '.$VehicleMaster['route_id'];
            //echo '<br>sSQLchk'.$sSQLchk;
            $res = mysqli_query($connection,$sSQLchk) or die(mysqli_error($connection));
            $aCheckpoints = array();
            while($aTmp = mysqli_fetch_assoc($res)){
                $aCheckpoints[$aTmp['route_polygon_id']][] = array('lat'=>$aTmp['latitude'],'lng'=>$aTmp['longitude'],'passes'=>0);
            }
            
            //$sqlGetPolygon = 'SELECT rp.points,number_of_passes,rp.id as route_polygon_id,rp.pocket_name,rp.total_distance FROM route_polygon rp LEFT JOIN vehicle_routes vr ON rp.route_id = vr.route_id WHERE  rp.route_id='.$VehicleMaster['route_id'].' AND vr.day='.$dayofweek;

            $sqlGetPolygon = 'SELECT rp.points,number_of_passes,rp.id as route_polygon_id,rp.pocket_name,rp.total_distance FROM route_polygon rp  WHERE  rp.route_id='.$VehicleMaster['route_id'];
            //echo '<br>sqlGetPolygon:'.$sqlGetPolygon;
            $res = mysqli_query($connection,$sqlGetPolygon) or die(mysqli_error($connection));

            while($aPolygonTmp = mysqli_fetch_assoc($res)){
                $CurrCheckpoints = isset($aCheckpoints[$aPolygonTmp['route_polygon_id']]) ? $aCheckpoints[$aPolygonTmp['route_polygon_id']] : array();
                $aRoutePoints[] = array('pocket_name'=>$aPolygonTmp['pocket_name'],'default_distance'=>$aPolygonTmp['total_distance'],'passes'=>$aPolygonTmp['number_of_passes'],'points'=>json_decode($aPolygonTmp['points']),'is_present'=>0,'pocket_in'=>0,'latest_pocket_in'=>0,'distance_travelled'=>0,'pocket_out'=>0,'pocket_total_time'=>0,'checkpoints'=>$CurrCheckpoints,'current_pass'=>0,'polygon_id'=>$aPolygonTmp['route_polygon_id']) ;
            }
            
            $sSQL = 'INSERT INTO daily_route_details(route_id,vehicle_number,device_number,current_day,latest_latitude,latest_longitude,latest_speed,latest_time,distance,is_present,`type`,`pockets`,week_day) VALUES('.$VehicleMaster['route_id'].', '.$VehicleMaster['vehicle_id'].', \''.mysqli_real_escape_string($connection,$VehicleMaster['device_number']).'\', '.$today.', \''.mysqli_real_escape_string($connection,$lat).'\', \''.mysqli_real_escape_string($connection,$lng).'\', \''.mysqli_real_escape_string($connection,$speed).'\','.strtotime('now').',0,0,'.$VehicleMaster['vehicle_type'].',\''.json_encode(($aRoutePoints)).'\','.$dayofweek.')';
            mysqli_query($connection,$sSQL) or die(mysqli_error($connection));
        }

        $route_folder = $root_folder.'/public/vehicle_details/'.$today;
        if(!is_dir($route_folder)){
            $oldmask = umask(0);
            mkdir($route_folder,0777);
            umask($oldmask);
        }
       
        $file_name = $VehicleMaster['vehicle_id'].'.json';
        $file_path = $route_folder.'/'.$file_name;
        
       try{
            $write_data = ',{"latitude":'.$lat.',"longitude":'.$lng.',"record_timestamp":"'.$time.'","record_date":"'.date('d-m-Y',$time).'","record_time":"'.date('H:i:s',$time).'","speed":"'.$speed.'","gpsinfo":"'.$gpsinfo.'","sat_quantity":"'.$sat_quantity.'"}';
            if(file_exists($file_path)){ 
                $saved_file = file_put_contents($file_path,$write_data,FILE_APPEND);
                if (($saved_file === false) || ($saved_file == -1)) {
                    $sdata = json_encode($VehicleMaster);
                    $message =  '['.$str_date_time.'] Error writing -, vehicledata: '.$sdata.PHP_EOL;
                    file_put_contents($log_file,$message,FILE_APPEND);
                }
            }
            else
            {
                if(!is_dir($route_folder)){
                    $oldmask = umask(0);
                    mkdir($route_folder,0777);
                    umask($oldmask);
                }
                $write_data = trim($write_data,',');
                file_put_contents($file_path,$write_data) or die('write error');
            }
       }
       catch(Exception $e) {
                $sdata = json_encode($VehicleMaster);
                $message =  '['.$str_date_time.'] Error on line '.$e->getLine().' , Message: add stop overspeed - ' .$e->getMessage().', vehicledata: '.$sdata.PHP_EOL;
                file_put_contents($log_file,$message,FILE_APPEND);
        }
    }   
}

function check_for_checkpoint($aCheckpoints,$lat,$lng,$current_pass,$i_max_pocket_passes){
    $point_number = -1;
    $aReturn['change_pass'] = 0;
    $aReturn['distance'] = 0;
    $points_achived_current_pass = 0;
    foreach($aCheckpoints as $key=>$point){
        if($point['passes'] == ($current_pass+1)){
            $points_achived_current_pass++;
        }
    }
    
    foreach($aCheckpoints as $key=>$point){
        if($point['passes'] < $i_max_pocket_passes &&  $point['passes'] == $current_pass){
            $distance = distanceCalculation($point['lat'],$point['lng'],$lat,$lng);
            //echo '<br>'.$distance;
            if($distance < CHKPOINT_DIST){
                $point_number = $key;
                $aReturn['distance'] = $distance;
                $points_achived_current_pass++;
                break;
            }
        }
    }
    if($points_achived_current_pass == count($aCheckpoints)){
        $aReturn['change_pass'] = 1;
    }
    $aReturn['point_achived'] = $point_number;
    return $aReturn;
}
function is_point_in_polygon($lat,$lng,$polygon){

    if(empty($polygon)) 
        return 0;
    $currentLocationPoints =  array('lat' =>$lat, 'lng' => $lng); 
    $response =  \GeometryLibrary\PolyUtil::containsLocation( 
          $currentLocationPoints,$polygon);
    if($response){
             return 1;
            }else{
            return 0;
            }
}

$sSQL = 'select device_number,vm.id as vehicle_id,vm.is_active as vehicle_active,(select type from vehicle_routes where vehicle_number=vm.id order by id desc limit 0,1) as vehicle_type FROM vehicle_master vm  WHERE device_number != \'\'';

$res = mysqli_query($con,$sSQL) or die('Query error 1');

while($aVehicleMaster = mysqli_fetch_assoc($res)){
    //if($aVehicleMaster['device_number'] != '0355172106130915') continue;
    $file_path = $root_folder.'/device/v5-data/'.$aVehicleMaster['device_number'].'.txt';
    
    if(file_exists($file_path)){
        /*
        Updated to save location data of only active vehicles and clear data file so that history should not update once vehicle is activated 
        */
        if($aVehicleMaster['vehicle_active']){
            $array = json_decode('['.trim(file_get_contents($file_path).']',','),1);
        
            if(!empty($array)){
                echo $aVehicleMaster['device_number'].'-started<br>';
                $Datacount = count($array);
                $count =0;
               
                foreach($array as $packet ){
                   // echo '<pre'.print_r($packet).'<br>';
                    if(!empty($packet))
                        process_data($con,$root_folder,$packet,$aVehicleMaster);
                }
                $fp = fopen($file_path, "w");
                fclose($fp);
                echo '-done >>><br>';
            }
        }else{
            $fp = fopen($file_path, "w");
            fclose($fp);
        }
    }
}
?>