@extends('layout.index')
@section('title','Calendar List')

<!-- Dashboard Ecommerce start -->
@section('content')
<section>
    <div class="content-body">
        <!-- Bordered table start -->
        <div class="row" id="table-bordered">
           <div class="col-12">
              <div class="card">
                 <div class="card-header w-100" >
                    <div class="content-header-left">
                       <div class="row breadcrumbs-top">
                          <div class="col-sm-12">
                             <h2 class="content-header-title float-left mb-0">Calendar Master</h2>
                          </div>
                       </div>
                    </div>
                    <div class="d-flex justify-content-end breadcrumb-wrapper">
                       <nav aria-label="breadcrumb">
                          <ol class="breadcrumb mr-1">
                             <li class="breadcrumb-item"><a href="javascript:void(0)">Home</a></li>
                             <li class="breadcrumb-item">Calendar Master</li>
                             <li class="breadcrumb-item active" aria-current="page">List</li>
                          </ol>
                       </nav>
                    </div>
                 </div>
              </div>
           </div>
        </div>
        <!-- Bordered table end -->
    </div>
        @if ($message = Session::get('success'))
            <div class="demo-spacing-0 mb-1">
                <div class="alert alert-success alert-dismissible fade show" role="alert">
                    <div class="alert-body">
                        <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                            {{ $message }}
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close">

                    </div>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                    </button>
                </div>
            </div>
        @elseif ($message = Session::get('error'))
            <div class="demo-spacing-0 mb-1">
                    <div class="alert alert-danger alert-dismissible fade show" role="alert">
                        <div class="alert-body">
                            <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                                {{ $message }}
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">

                        </div>
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
           </div>
        @endif
    <div class="content-body">
        <!-- Bordered table start -->
        <div class="row" id="table-bordered">
            <div class="col-12">
                <div class="card">
                <form class="dt_adv_search" action="{{url('calendar/search')}}" method="POST" autocomplete="off">
                    <input type="hidden" name="form_type" value="search_form">
                    @csrf
                    <div class="card-header w-100" >
                        <div class="row w-100" >
                            <div class="col-sm-8">
                                <div class="row">
                                    <div class="col-sm-3">
                                        <div class="form-group m-0">
                                        <input type="text" id="txt_from_date" class="form-control flatpickr-date-min" name="txt_from_date" placeholder="Start Date" value="<?php echo ($txt_from_date)?$txt_from_date:''; ?>"/>
                                        </div>
                                        <h5><small class="text-danger" id="txt_from_date_err"></small></h5>
                                    </div>

                                    <div class="col-sm-3">
                                        <div class="form-group m-0">
                                         <input type="text" id="txt_to_date" class="form-control flatpickr-date-min" name="txt_to_date" placeholder="End Date" value="<?php echo ($txt_to_date)?$txt_to_date:''; ?>"/>
                                        </div>
                                        <h5><small class="text-danger" id="txt_to_date_err"></small></h5>
                                    </div>

                                    <div class="col-sm-3">
                                        <div class="form-group m-0">
                                        <select name="vehicle_number" id="vehicle_number" class="select2 form-select">
                                            <option value="">--- Select Vehicle ---</option>
                                            @foreach($vehicle as $val)
                                            
                                            @php $selected = '';   @endphp 
                                            @if($vehicle_id == $val->id)
                                            @php $selected ='selected'; @endphp
                                            @endif
                                            <option {{ $selected }} value="{{$val->id}}" > {{$val->vehicle_number }}</option>
                                            @endforeach  
                                            
                                        </select>
                                        </div>
                                    </div>

                                    <div class="col-sm-3">
                                        <div class="form-group m-0">
                                            <select name="route_id" id="route_id" class="select2 form-control">
                                                <option value="">Select Route</option>
                                                @foreach($aRoutes as $val)
                                                    <option value="{{$val->id}}" <?php echo ($route_id == $val->id)? 'selected':''; ?>>{{$val->route_name}}</option>
                                                @endforeach            
                                            </select>
                                        </div>
                                    </div>

                                    <div class="col-sm-3">
                                        <!-- <label class="form-label">&nbsp;</label><br> -->
                                        <button type="submit" class="btn btn-primary" name="btn_submit" onclick="return validation();">Search</button>

                                        @if($search)
                                        <a title="Clear" href="{{ url('calendar/clear_search') }}" class="btn btn-outline-primary" data-column="3"><i data-feather="rotate-ccw" class="me-25"></i><span> Clear</span></a> 
                                        @endif
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </form>
                    <div class="table-responsive">
                        <table class="table table-striped table-bordered">
                        <thead>
                            <tr>
                                <th width="2%" class="text-center">Sr.No</th>
                                <th width="2%">Date</th>
                                <th width="8%">Route Name</th>
                                <th width="4%">Vehicle No</th>
                              </tr>
                        </thead>
                        <tbody class="text-center">
                            
                            <?php
                              $i = 0;
                            if(!empty($records)){

                                foreach ($records as $value) {
                                $i++; 
                                
                                $date =  ($value['date'])? date('d-m-Y',strtotime($value['date'])):'';  
                             ?>
                            
                            <tr>
                                <td width="2%"><?php echo $i; ?></td>
                                <td width="2%" class="text-left"><?php echo $date; ?></td>
                                <td width="8%" class="text-left">

                                <?php 

                                  if($value['route_name']){
                                   echo $value['route_name'];
                                  }else{ ?>
                                    <p>&#10005;</p>
                                <?php } ?>

                                </td>
                                <td width="4%" class="text-left">
                                  <?php 

                                  if($value['vehicle']){
                                   echo $value['vehicle'];
                                  }else{ ?>
                                    <p>&#10005;</p>
                                      <?php } ?>
                                  </td>
                            </tr>
                            <?php 
                             }
                            }else{
                            ?>
                            <tr>
                                <td colspan="4" style="text-align:center; color:red;">No Record Found</td>
                            </tr>
                                     
                            <?php 
                             }
                            ?>                    
                        </tbody>
                        </table>
                        
                        <div class="card-body">
                                <div class="d-flex justify-content-end">
                                   
                                </div>   
                        </div>
                        
                    </div>
                </div>
            </div>
        </div>
        <!-- Bordered table end -->
    </div>

<script>
    function validation(){

        if ($('#txt_from_date').val() == ""){
        $('#txt_from_date').parent().addClass('has-error');
        $('#txt_from_date_err').html('Please Select Start Date.');
        $('#txt_from_date').focus();
        $('#txt_from_date').change(function () {
        $('#txt_from_date').parent().removeClass('has-error');
        $('#txt_from_date_err').html('');
        });
        return false;
       }

       if ($('#txt_to_date').val() == ""){
        $('#txt_to_date').parent().addClass('has-error');
        $('#txt_to_date_err').html('Please Select End Date.');
        $('#txt_to_date').focus();
        $('#txt_to_date').change(function () {
        $('#txt_to_date').parent().removeClass('has-error');
        $('#txt_to_date_err').html('');
        });
        return false;
        }

        if ($('#txt_from_date').val() != "" && $('#txt_to_date').val() != ""){

            var from_date = $('#txt_from_date').val().split("-");

            var y_year  = from_date[2];
            var y_month = from_date[1]
            var y_day   = from_date[0];

            var txt_from_date = y_year+''+y_month+''+y_day;

            var to_date = $('#txt_to_date').val().split("-");

            var t_year  = to_date[2];
            var t_month = to_date[1]
            var t_day   = to_date[0];

            var txt_to_date = t_year+''+t_month+''+t_day;

            if(txt_to_date < txt_from_date){
                 
                $('#txt_to_date').parent().addClass('has-error');
                $('#txt_to_date_err').html('Please End Date Greater than Equal to Start Date.');
                $('#txt_to_date').focus();
                $('#txt_to_date').change(function () {
                $('#txt_to_date').parent().removeClass('has-error');
                $('#txt_to_date_err').html('');
               });
               return false;
            }
            
        }
    }


</script>
</section>

@endsection





  

