@extends('layout.index')
@section('title', 'Attendance Details')

<!-- Dashboard Ecommerce start -->
@section('content')
    <section>
        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header w-100">
                            <div class="content-header-left">
                                <div class="row breadcrumbs-top">
                                    <div class="col-sm-12">
                                        <h2 class="content-header-title float-left mb-0">Attendance Details</h2>
                                    </div>
                                </div>
                            </div>
                            <div class="d-flex justify-content-end breadcrumb-wrapper">
                                <nav aria-label="breadcrumb">
                                    <ol class="breadcrumb mr-1">
                                        <li class="breadcrumb-item"><a href="javascript:void(0)">Home</a></li>
                                        <li class="breadcrumb-item">Employee</li>
                                        <li class="breadcrumb-item active" aria-current="page">Attendance Details</li>
                                    </ol>
                                </nav>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- Bordered table end -->
        </div>
        @if ($message = Session::get('success'))
            <div class="demo-spacing-0 mb-1">
                <div class="alert alert-success alert-dismissible fade show" role="alert">
                    <div class="alert-body">
                        <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                        {{ $message }}
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close">

                    </div>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
            </div>
        @endif

        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header ">
                            <div class="row w-100">
                                <div class="col-sm-8">
                                    <form class="dt_adv_search"
                                        action="{{ url('/biometric_attendance/attendance_search', $Emp_data[0]->id) }}"
                                        method="POST">
                                        @csrf
                                        <input type="hidden" name="form_type" value="search_frm">
                                        <div class="row g-1 mb-md-1">
                                            <div class="col-md-3">
                                                <label class="form-label">From Date</label>
                                                <input id="start_date" name="start_date"
                                                    class="form-control flatpickr-basic" type="text"
                                                    value="{{ $start_date }}">
                                                </select>
                                            </div>

                                            <div class="col-md-3">
                                                <label class="form-label">To Date</label>
                                                <input id="end_date" name="end_date" class="form-control flatpickr-basic"
                                                    type="text" value="{{ $end_date }}">
                                                </select>
                                            </div>
                                            <div class="col-md-4">
                                                <label class="form-label">&nbsp;</label><br>
                                                <button title="Search" type="submit" class="btn btn-outline-primary"
                                                    data-column="3"><i data-feather="search"
                                                        class="me-25"></i><span> Search</span></button>

                                                @if ($search)
                                                    <a title="Clear"
                                                        href="{{ url('/biometric_attendance/clear_attendance_search', $Emp_data[0]->id) }}"
                                                        class="btn btn-outline-primary" data-column="3"><i
                                                            data-feather="rotate-ccw"
                                                            class="me-25"></i><span> Clear</span></a>
                                                @endif
                                            </div>
                                        </div>
                                    </form>
                                </div>
                                <div class="col-sm-4">
                                    <a href="{{ route('employee.list') }}"
                                        class="btn btn-outline-primary float-right mt-2"><span>Back</span></a>
                                </div>
                            </div>
                        </div>
                        <div class="row " style="padding-left: 20px;">
                            <div class="col-sm-2">
                            <h5><strong>Employee Id :- </strong>{{ $Emp_data[0]->emp_id }} </h5>
                            </div>
                            <div class="col-sm-5">
                                <h5><strong>Employee Name :- </strong>{{ ucfirst($Emp_data[0]->firstname)." ".ucfirst($Emp_data[0]->middlename)." ".ucfirst($Emp_data[0]->lastname) }}</h5>
                            </div>
                        </div>

                        <div class="table-responsive mt-1">
                            <table class="table table-striped table-bordered">
                                <thead>
                                    <tr>
                                        <th class="text-center">Sr.No</th>
                                        <th class="text-left">Date</th>
                                        <th class="text-left">In Time</th>
                                        <th class="text-left">Out Time</th>
                                        <th class="text-center">Attendance</th>
                                        <th class="text-center">View Details</th>
                                    </tr>
                                </thead>
                                <tbody class="text-left">
                                   
                                    <?php if(!empty($aAttendance)){ 
                                      // dd(count($aAttendance));
                                         if(count($aAttendance) != 0){
                                        ?>
                                        
                                        @php
                                            $i = 1;
                                            $i = $aAttendance->perPage() * ($aAttendance->currentPage() - 1);
                                        @endphp

                                        @foreach ($aAttendance as $val)
                                            @php $i++; @endphp
                                            <tr>
                                                <td class="text-center">{{ $i }}</td>
                                                <td>{{ date('d-m-Y', $val->attendance_date) }}</td>
                                                <td>
                                                    <?php if($val->inward_datetime != 0){
                                                           echo date('h:i A', $val->inward_datetime);
                                                    }else{ echo '-'; } ?> 
                                                </td>
                                                <td>
                                                    <?php if($val->outword_datetime != 0){
                                                        echo date('h:i A', $val->outword_datetime);
                                                    }else{ echo '-'; } ?>
                                                </td>
                                                <td class="text-center">
                                                    @if (isset($val->success) && $val->success == 1)
                                                        <div class="badge badge-success">Present</div>
                                                    @else
                                                        <div class="badge badge-danger">Absent</div>
                                                    @endif
                                                </td>
                                                <td class="text-center">
                                                    <form method="post"
                                                        action="{{ route('employee.attendance_log', [$val->id, $val->user_id]) }}">
                                                        @csrf
                                                        <input type="hidden" name="form_type" value="view_data">
                                                        <input type="hidden" name="date"
                                                            value={{ $val->attendance_date }}>

                                                        <button type="submit" class="btn btn-icon btn-outline-primary"> <i
                                                                class="fa fa-eye" aria-hidden="true"></i> View</button>
                                                        {{-- <a href="{{ route('employee.attendance_log', [$val->user_id,$val->attendance_date]) }}" class="btn btn-icon btn-outline-primary">
                                                        <i class="fa fa-eye" aria-hidden="true"></i> View
                                                    </a> --}}
                                                    </form>
                                                </td>

                                            </tr>
                                        @endforeach
                                   <?php }else{ ?>
                                        <tr>
                                            <td colspan="6" style="text-align: center; color:red;">No Record Found.</td>
                                        </tr>
                                    <?php } }?>
                                </tbody>
                            </table>
                            <div class="card-body">
                                <div class="d-flex justify-content-end">
                                    {{ $aAttendance->links() }}
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
            <!-- Bordered table end -->
        </div>
    </section>
@endsection
