@extends('layout.index')
@section('title', 'Present Absent Report')

<!-- Dashboard Ecommerce start -->
@section('content')
    <section>
        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header w-100">
                            <div class="content-header-left">
                                <div class="row breadcrumbs-top">
                                    <div class="col-sm-12">
                                        <h2 class="content-header-title float-left mb-0"> Present Absent Report </h2>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- Bordered table end -->
        </div>
        @if ($message = Session::get('success'))
            <div class="demo-spacing-0 mb-1">
                <div class="alert alert-success alert-dismissible fade show" role="alert">
                    <div class="alert-body">
                        <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                        {{ $message }}
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close">

                    </div>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
            </div>
        @endif

        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <form class="dt_adv_search" action="{{ url('/reports/present_report') }}" method="POST">
                            @csrf
                            <input type="hidden" name="form_type" value="search_frm">
                            <div class="card-header w-100">
                                <div class="row w-100">
                                    <div class="col-sm-9">
                                        <div class="row">
                                            <div class="col-sm-3">
                                                <div class="form-group m-0">
                                                    <label class="form-label">Pakage</label>
                                                    <select name="Pakage_id" class="select2 form-select">
                                                        <option value="">Select Pakage</option>
                                                        @foreach ($aPakage as $val)
                                                            @php $selected = '';   @endphp
                                                            @if ($Pakage_id == $val->id)
                                                                @php $selected ='selected'; @endphp
                                                            @endif
                                                            <option value="{{ $val->id }}" {{ $selected }}>
                                                                {{ $val->Pakage_name }}
                                                            </option>
                                                        @endforeach
                                                    </select>
                                                </div>
                                            </div>

                                            <div class="col-md-3">
                                                <label class="form-label">Start Date</label>
                                                <input id="start_date" name="start_date"
                                                    class="form-control flatpickr-basic" type="text"
                                                    value="{{ $start_date }}">
                                                </select>
                                            </div>

                                            <div class="col-md-3">
                                                <label class="form-label">End Date</label>
                                                <input id="end_date" name="end_date" class="form-control flatpickr-basic"
                                                    type="text" value="{{ $end_date }}">
                                                </select>
                                            </div>

                                            <div class="col-sm-3">
                                                <label class="form-label">&nbsp;</label><br>
                                                <button type="submit" class="btn btn-primary">Search</button>

                                                @if ($search)
                                                            <a title="Clear" href="{{ url('/reports/clear_search/present_report') }}"
                                                        type="button" class="btn btn-outline-primary">
                                                        <i data-feather="rotate-ccw" class="me-25"></i> Clear
                                                    </a>
                                                @endif
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-sm-3">
                                        <div style="float: right; margin-top: 25px;">
                                        @if (sizeof($aPresent))
                                            <a href="{{ url('/reports/present_absent/export_excel') }}" 
                                            class="btn btn-outline-primary"><i class='fa fa-download' arial-hidden="true"></i> Excel</a>
                                        @endif     
                                            <a href="{{ url('reports') }}" 
                                            class="btn btn-outline-primary"><span>Back</span></a>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </form>
                        <div class="table-responsive">
                            <table class="table table-striped table-bordered">
                                <thead>
                                    <tr>
                                        <th class="text-center">Sr.No</th>
                                        <th>Emp Id</th>
                                        <th>Emp Name</th>
                                        <th>Pakage</th>
                                        <th class="text-center">Present Days</th>
                                        <th class="text-center">Absent Days</th>
                                        <th class="text-center">Working Days</th>
                                        <th class="text-center">Photo</th>
                                    </tr>
                                </thead>
                                <tbody class="text-left">
                                    @if (sizeof($aPresent))
                                        @php
                                            $i = 0;
                                        @endphp
                                        @foreach ($aPresent as $val)
                                            @php
                                                $i++;
                                            @endphp
                                            <tr>
                                                <td class="text-center">{{ $i }}</td>
                                                <td>{{ $val->emp_id }}</td>
                                                <td>{{ $val->employee }}</td>
                                                <td>{{ $val->Pakage_name }}</td>
                                                <td class="text-center">{{ $val->present_day }}</td>
                                                <td class="text-center">{{ $val->absent_day }}</td>
                                                <td class="text-center">{{ $val->working_day }}</td>
                                                <td class="text-center">
                                                    @if($val->image_url)
                                                        <div class="avatar avatar-lg">
                                                        <a href={{ asset('/uploads/employee_images/'.$val->image_url) }} target="_blank">
                                                            <img src={{ asset('/uploads/employee_images/'.$val->image_url) }} alt="avatar" /></a>
                                                        </div>
                                                    @else
                                                        <div>
                                                           No Image
                                                            <!-- <img  src={{ asset('app-assets/images/portrait/small/proflie-default.png')}} alt="avatar" /> -->
                                                       
                                                        </div>
                                                    @endif
                                                </td>
                                            </tr>
                                        @endforeach
                                    @else
                                        <tr>
                                            <td colspan="16" style="text-align: center; color:red;">No Record Found.</td>
                                        </tr>
                                    @endif
                                </tbody>
                            </table>
                            <div class="card-body">
                                <div class="d-flex justify-content-end">
                                    {{ $aPresent->links() }}
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- Bordered table end -->
        </div>
    </section>
@endsection
