@extends('layout.index')
@section('title','Vehicle Sweeping Coverage')

<!-- Dashboard Ecommerce start -->
@section('content')
<section>
    <div class="content-body">
        <!-- Bordered table start -->
        <div class="row" id="table-bordered">
           <div class="col-12">
              <div class="card">
                 <div class="card-header w-100" >
                    <div class="content-header-left">
                       <div class="row breadcrumbs-top">
                          <div class="col-sm-12">
                             <h2 class="content-header-title float-left mb-0">Vehicle Sweeping Coverage List</h2>
                          </div>
                       </div>
                    </div>
                    <div class="d-flex justify-content-end breadcrumb-wrapper">
                       <nav aria-label="breadcrumb">
                          <ol class="breadcrumb mr-1">
                             <li class="breadcrumb-item"><a href="javascript:void(0)">Home</a></li>
                             <li class="breadcrumb-item">Vehicle Sweeping Coverage</li>
                             <li class="breadcrumb-item active" aria-current="page">Vehicle Sweeping Coverage List</li>
                          </ol>
                       </nav>
                    </div>
                 </div>
              </div>
           </div>
        </div>
        <!-- Bordered table end -->
    </div>
        @if ($message = Session::get('success'))
            <div class="demo-spacing-0 mb-1">
                <div class="alert alert-success alert-dismissible fade show" role="alert">
                    <div class="alert-body">
                        <i class="fa fa-check-circle" style="font-size:16px;" aria-hidden="true"></i>
                            {{ $message }}
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close">

                    </div>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                    </button>
                </div>
            </div>
        @endif

    <div class="content-body">
        <!-- Bordered table start -->
        <div class="row" id="table-bordered">
            <div class="col-12">
                <div class="card">
                    <form class="dt_adv_search" action="{{url('vehicle_tracking_reports/vehicle_sweeping_coverage')}}" method="POST">
                            @csrf
                        <div class="card-header w-100" >
                            <div class="row w-100" >
                                <div class="col-sm-8">
                                    <div class="row">

                                        <div class="col-sm-3">
                                            <div class="form-group m-0">
                                            <!-- <label class="form-label">Pakage</label> -->
                                            <input type="text" id="txt_date" class="form-control" name="txt_date" value="{{ $txt_date; }}" placeholder="Date" autocomplete="off">
                                            </div>
                                        </div>

                                        <div class= "col-sm-3">
                                           
                                           <button type="submit" name="btn_search" class="btn btn-primary">Search</button>
                                            
                                          @if ($txt_date)
                                              <button type="submit" name="btn_reset" class="btn btn-outline-primary"><i data-feather="rotate-ccw" class="me-25"></i> Clear</button>
                                            @endif    
                                        </div>
                                    </div>
                                </div>
                                <div class="col-sm-4">
                                    <div style="float: right;">
                                        
                                        <a href="{{url('vehicle_tracking_reports/vehicle_sweeping_coverage_excel',['date'=>base64_encode($txt_date)])}}" 
                                        class="btn btn-outline-primary"><i class='fa fa-download' arial-hidden="true"></i> Excel</a>
                                     
                                        <a href="{{ url('/vehicle_tracking_reports') }}" 
                                        class="btn btn-outline-primary"><span>Back</span></a>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </form>
                <!-- index.blade.php -->

<div class="table-responsive">
    <table class="table table-striped table-bordered">
        <thead>
            <tr>
                <th class="text-center">Sr.No</th>
                <th>Vehicle Number</th>
                <th>Vehicle Type</th>
                <th>Route Name</th>
                <th>Default Route Point</th>
                <th>Covered Route Point</th>
                <th>Route Covered Percentage</th>
            </tr>
        </thead>
        <tbody class="text-left">
                    <?php 
                      if(!empty($records)){
                       $i = 0;
                       $pocket1 = array();
                      foreach ($records as $value) {
                        
                        $i++; 
                        
                        $pocket1 = json_decode($value->pockets);
                        
                        $default_route_point = '';
                        $covered_route_point = '';
                        $route_covered_per = '';

                        if(!empty($pocket1)){
                            $default_route_point .= '<table width="100%">';
                            $covered_route_point .= '<table width="100%">';
                            $route_covered_per   .= '<table width="100%">';
                            foreach ($pocket1 as $pocket1_val) {
                                
                                $pocket_name = $pocket1_val->pocket_name;
                                $passes = $pocket1_val->passes;
                                $checkpoints = count($pocket1_val->checkpoints);
                                $points_val = $passes*$checkpoints;

                                $default_route_point .= '<tr><td style="text-align: center;">'.$pocket_name.'</td><td style="text-align: center;">'.$points_val.'</td></tr>'; 
                                

                                $check_passes = array_sum(array_column($pocket1_val->checkpoints,'passes'));

                                $covered_route_point .= '<tr><td style="text-align: center;">'.$check_passes.'</td></tr>';
                                
                                $route_covered_per_val = 0;
                                if($points_val){
                                $route_covered_per_val = ($check_passes / $points_val)*100; 
                                }
      
                                $route_covered_per .= '<tr><td style="text-align: center;">'.round($route_covered_per_val,2).' %</td></tr>';

                            } 

                            $route_covered_per   .= '</table>'; 
                            $covered_route_point .= '</table>'; 
                            $default_route_point .= '</table>'; 
                        }
                        
                    ?>  
                        <tr>
                            <td class="text-center"><?php echo $i; ?></td>
                            <td><?php echo $value->vehicle_number; ?></td>
                            <td><?php echo $value->type; ?></td>
                            <td><?php echo $value->route_name; ?></td>
                            <td><?php echo $default_route_point; ?></td>
                            <td><?php echo $covered_route_point; ?></td>
                            <td><?php echo $route_covered_per; ?></td>
                        </tr>
                    <?php 
                       }
                      }else{
                    ?> 
                    <tr>
                        <td colspan="8" style="text-align:center; color:red;">No Record Found</td>
                    </tr>
                    <?php 
                       }
                    ?> 
        </tbody>
    </table>
</div>

                </div>

            </div>
        </div>
        <!-- Bordered table end -->
    </div>
</section>

<script src="https://code.jquery.com/jquery-3.6.0.min.js" integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>
<link rel="stylesheet" href="//code.jquery.com/ui/1.13.2/themes/base/jquery-ui.css">
<script src="https://code.jquery.com/ui/1.13.2/jquery-ui.js"></script>

<script>

       $("#txt_date").datepicker({
            changeMonth: true,
            changeYear: true,
            dateFormat: 'dd-mm-yy'
        });
   </script>
@endsection
