@extends('layout.index')
@section('title','Route Add')
<!-- Dashboard Ecommerce start -->
@section('content')
<section>
   
    <div class="content-body">
        <!-- Bordered table start -->
        <div class="row" id="table-bordered">
           <div class="col-12">
              <div class="card">
                 <div class="card-header w-100" >
                    <div class="content-header-left">
                       <div class="row breadcrumbs-top">
                          <div class="col-sm-12">
                             <h2 class="content-header-title float-left mb-0">Add Route</h2>
                          </div>
                       </div>
                    </div>
                    <div class="d-flex justify-content-end breadcrumb-wrapper">
                       <nav aria-label="breadcrumb">
                          <ol class="breadcrumb mr-1">
                             <li class="breadcrumb-item"><a href="javascript:void(0)">Home</a></li>
                             <li class="breadcrumb-item">Route Master</li>
                             <li class="breadcrumb-item active" aria-current="page">Add</li>
                          </ol>
                       </nav>
                    </div>
                 </div>
              </div>
           </div>
        </div>
        <!-- Bordered table end -->
     </div>

    @if ($message = Session::get('success'))
        <div class="demo-spacing-0 mb-1">
            <div class="alert alert-success alert-dismissible fade show" role="alert">
                <div class="alert-body">
                    {{-- <i class="fa fa-exclamation-triangle" aria-hidden="true"></i> --}}
                        {{ $message }}
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">

                </div>
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
                </button>
            </div>
        </div>
    @endif
   
   <div class="content-body">
        <section id="multiple-column-form">
            <div class="row justify-content-center">
                <div class="col-sm-12">
                    <div class="card">
                        <div class="card-body">
                            <form class="form" action="{{route('route_master.store')}}" method="post">
                                {{csrf_field()}}                        
                                    <div class="row">

                                        <div class="col-md-6 col-12">
                                            <div class="form-group">
                                                <label for="module_caption">Route Name <span style="color:red;">*</span></label>
                                                <input type="text" id="route_name" class="form-control" placeholder="Enter Route Name" name="route_name" value="{{ old('route_name') }}" autocomplete="off"/>
                                                @error('route_name')<span class="error"  style="color: red;">{{ $message }}</span>@enderror
                                                <h5><small class="text-danger" id="route_name_err"></small></h5>
                                            </div>
                                        </div>

                                        <div class="col-md-6 col-12">
                                            <div class="form-group">
                                                <label for="basicSelect">Pakage <span style="color:red;">*</span></label>
                                                <select class="select2 form-select" id="Pakage_id" name="Pakage_id" onChange="get_wards()" value="{{ old('Pakage_id') }}" >
                                                <option value="">Select Pakage</option>
                                                @foreach($Pakages as $val)
                                                    <option value="{{ $val->id }}">{{ $val->Pakage_name }}</option>
                                                @endforeach 
                                                </select>
                                                <h5><small class="text-danger" id="Pakage_id_err"></small></h5>
                                            </div>
                                         </div>

                                         <div class="col-md-6 col-12">
                                            <div class="form-group">
                                                <label for="select2 form-select">Ward </label>
                                                <select class="select2 form-select" id="ward_id" name="ward_id">
                                                <option value="0">--All Wards--</option>
                                                @foreach($wards as $val)
                                                    <option value="{{ $val->id }}">{{ $val->ward_name }}</option>
                                                @endforeach 
                                                </select>
                                             </div>
                                         </div>

                                        <hr class="m-1">
                                        <div class="col-12 text-center mt-1">
                                            <input type="submit" name="command" class="btn btn-primary mr-1" value="Save" onClick="return validation()">
                                            <a href="{{ route('route_master.index') }}" class="btn btn-outline-secondary">Cancel</a>
                                        </div>
                                    </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </section>
   </div>
</section>
@endsection

<script src="https://code.jquery.com/jquery-3.6.0.min.js" integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>

<script>
	
	function get_wards(){
		var Pakage_id = $('#Pakage_id').val();
        $.ajax({
                type: "post",
                url: "{{ url('/route_master/wards') }} ",
                data:{"_token": "{{ csrf_token() }}","Pakage_id":Pakage_id},
                success: function(response){
                  // alert(response);
                   $('#ward_id').html(response); 
                },
                error: function(){						
                    alert("Error while request..");
                }
        });
		
    }
</script>




<script type="text/javascript">
	function validation() {

      if ($('#route_name').val() == ""){
         $('#route_name').parent().addClass('has-error');
         $('#route_name_err').html('Please Enter Route Name.');
         $('#route_name').focus();
         $('#route_name').keyup(function () {
         $('#route_name').parent().removeClass('has-error');
         $('#route_name_err').html('');
        });
        return false;
      }
     
      if ($('#Pakage_id').val() == ""){
         $('#Pakage_id').parent().addClass('has-error');
         $('#Pakage_id_err').html('Please Select Pakage.');
         $('#Pakage_id').focus();
         $('#Pakage_id').change(function () {
         $('#Pakage_id').parent().removeClass('has-error');
         $('#Pakage_id_err').html('');
        });
        return false;
      }
      
    }
</script>