@extends('layout.index')
@section('title','Supervisor List')

<!-- Dashboard Ecommerce start -->
@section('content')
<section>
    <div class="content-body">
        <!-- Bordered table start -->
        <div class="row" id="table-bordered">
           <div class="col-12">
              <div class="card">
                 <div class="card-header w-100" >
                    <div class="content-header-left">
                       <div class="row breadcrumbs-top">
                          <div class="col-sm-12">
                             <h2 class="content-header-title float-left mb-0">Supervisor List</h2>
                          </div>
                       </div>
                    </div>
                    <div class="d-flex justify-content-end breadcrumb-wrapper">
                       <nav aria-label="breadcrumb">
                          <ol class="breadcrumb mr-1">
                             <li class="breadcrumb-item"><a href="javascript:void(0)">Home</a></li>
                             <li class="breadcrumb-item">Supervisor Routes</li>
                             <li class="breadcrumb-item active" aria-current="page">Supervisor List</li>
                          </ol>
                       </nav>
                    </div>
                 </div>
              </div>
           </div>
        </div>
        <!-- Bordered table end -->
    </div>
        @if ($message = Session::get('success'))
            <div class="demo-spacing-0 mb-1">
                <div class="alert alert-success alert-dismissible fade show" role="alert">
                    <div class="alert-body">
                        <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                            {{ $message }}
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close">

                    </div>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                    </button>
                </div>
            </div>
        @endif

    <div class="content-body">
        <!-- Bordered table start -->
        <div class="row" id="table-bordered">
            <div class="col-12">
                <div class="card">
                    
                    <form class="dt_adv_search" action="{{url('supervisors/search')}}" method="POST" >
                        <input type="hidden" name="form_type" value="search_form">
                        @csrf
                        <div class="card-header w-100" >
                            <div class="row w-100" >
                            <div class="col-sm-8">
                                <div class="row">
                                <div class="col-sm-4">
                                    <div class="form-group m-0">
                                    <!-- <label class="form-label">Pakage</label> -->
                                    <select class="select2 form-select" id="Pakage_id" name="Pakage_id" onChange="get_wards()">
                                        <option value="">--- Select Pakage ---</option>
                                        @foreach($Pakages as $val)

                                            @php $selected = '';   @endphp 
                                            @if($Pakage_id == $val->id)
                                            @php $selected ='selected'; @endphp
                                            @endif
                                       
                                        <option {{ $selected }} value="{{ $val->id }}">{{ $val->Pakage_name }}</option>
                                        @endforeach 
                                    </select>
                                    </div>
                                </div>

                                <div class="col-sm-4">
                                    <div class="form-group m-0">
                                        <input type="text" name="supervisors_name" id="supervisors_name" class="form-control" placeholder="Search Supervisor Name" value="{{$supervisors_name}}" autocomplete="off">
                                     </div>
                                </div>

                                <div class="col-sm-4">
                                    <!-- <label class="form-label">&nbsp;</label><br> -->
                                    <button type="submit" class="btn btn-primary">Search</button>
                                    @if($search)
                                        <a title="Clear" href="{{ url('supervisors/clear_search') }}" class="btn btn-outline-primary">
                                        <i data-feather="rotate-ccw" class="me-25"></i> Clear</a> 
                                    @endif
                                   
                                </div>

                                </div>
                            </div>
                            <div class="col-sm-4">
                                <a href="{{ route('supervisors.create') }}" class="btn btn-outline-primary float-right"> <i data-feather="plus" class="me-25"></i><span>Add Supervisor</span></a>
                            </div>
                            </div>
                        </div>
                    </form>
                    <div class="table-responsive">
                        <table class="table table-striped table-bordered">
                        <thead>
                            <tr>
                                <th class="text-center">Sr.No</th>
                                <th class="text-left">Pakage</th>
                                <th class="text-left">Supervisor Name</th>
                                <th class="text-left">GPS Device Number</th>
                                <th class="text-left">User Name</th>
                                <th class="text-center">Assign Ward</th>
                                <th class="text-center">Add Device</th>
                                <th class="text-center">Status</th>
                                <th class="text-center">Action</th>
                              </tr>
                        </thead>
                        <tbody class="text-left">
                            @if($aSupervisor)
                               @if(count($aSupervisor) != 0)
                                @php $i=0;
                                @endphp
                                    @foreach($aSupervisor as $val)  
                                    @php
                                        $i++;
                                    @endphp                                  
                                        <tr>
                                            <td class="text-center">{{ $i }}</td>
                                            <td class="text-left">{{ $val->Pakage_name }}</td>
                                            <td class="text-left">{{ $val->supervisor_name }}</td>
                                            <td class="text-left"><?php if($val->gps_device_number != '0') { echo $val->gps_device_number; }else{ echo '-'; } ?></td>
                                            <td class="text-left">{{ $val->user_name }}</td>
                                            <td class="text-center">
                                                <a href="{{ url('/supervisors/assignward/'.$val->id.'/0') }}"  title="Assign Wards" ><i data-feather="user-plus"></i>  </a> 
                                            </td>
                                            <td class="text-center">
                                                <a href="{{ url('/supervisors/devices',$val->id) }}"  title="Add Device" ><i data-feather="edit"></i>  </a> 
                                            </td>
                                            <td class="text-center">
                                                <div class="custom-control custom-switch custom-switch-success">
                                                    <input type="checkbox" class="custom-control-input"
                                                        id="{{ $val->id }}"
                                                        {{ $val->active ? 'checked' : '' }}
                                                        onclick="change_status(event.target, {{ $val->id }});" />
                                                    <label class="custom-control-label" for="{{ $val->id }}">
                                                        <span class="switch-icon-left"></span>
                                                        <span class="switch-icon-right"></span>
                                                    </label>
                                                </div>
                                            </td>
                                            <td class="text-center">
                                                <div class="dropdown">
                                                    <button type="button" class="btn btn-sm dropdown-toggle hide-arrow"
                                                        data-toggle="dropdown">
                                                        <i data-feather="more-vertical"></i>
                                                    </button>
                                                    <div class="dropdown-menu">
                                                            <a class="dropdown-item"
                                                                href="{{ route('supervisors.edit', $val->id) }}">
                                                                <i data-feather="edit-2" class="mr-50"></i>
                                                                <span>Edit</span>
                                                            </a>
                                                            
                                                        <form method="POST" action="{{ route('supervisors.destroy', $val->id ) }}">
                                                            @csrf
                                                            <input type="hidden" name="_method" value="DELETE">
                                                            <button type="submit" class="dropdown-item" onclick="return confirm('Are you sure you want to delete this record?')">
                                                            <i data-feather="trash" class="mr-50" ></i>Delete
                                                            </button>
                                                          </form>
                                                    </div>
                                                </div>
                                            </td>
                                        </tr>
                                    @endforeach
                                    @else
                                    <tr>
                                        <td colspan="8" style="text-align:center; color:red;">No Record Found</td>
                                    </tr>
                                    @endif 
                                    @endif                  
                        </tbody>
                        </table>
                        <div class="card-body">
                                <div class="d-flex justify-content-end">
                                    {{ $aSupervisor->links() }}
                                </div>   
                        </div>
                    </div>
                </div>

            </div>
        </div>
        <!-- Bordered table end -->
    </div>
    <?php $live_url = config('custom.base_url'); ?>
</section>
@endsection
<script>
    function change_status(_this, id) {
        console.log(id);
        if (confirm("Are you sure want to change this status?")) {
            var status = $(_this).prop('checked') == true ? 1 : 0;
            let _token = $('meta[name="csrf-token"]').attr('content');

            $.ajax({
                //url: '/supervisors/change_status',
                url: "<?php echo $live_url; ?>supervisors/change_status",
                type: 'post',
                data: {
                    _token: "{{ csrf_token() }}",
                    id: id,
                    status: status
                },
                success: function(result) {}
            });
        }else{
            location.reload(); 
        }
    }
</script>