@extends('layout.index')
@section('title', 'Checkpoint Arrival Consolidated Report')

<style>
	.redtd{
		background-color: #ffc4c4 !important;
		color:red !important;
	}

	.dark-layout .redtd{
		    background-color: #742424 !important;
    	color: #ffbcbc !important;
	}
	
	.skyblue{
		background-color: skyblue !important;	
		color: #fff !important;
	}
	
    .greentd{
        background-color: #b1ffb1 !important;
		color: green !important;
       }

 	.dark-layout .greentd {
    background-color: #214e21 !important;
    color: #05ff05 !important;
}
	.border_bottom{
		border-bottom:1px solid gray !important;
	}
</style>

<!-- Dashboard Ecommerce start -->
@section('content')
    @php
    use Carbon\Carbon;
    @endphp
    <section>
        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header w-100">
                            <div class="content-header-left">
                                <div class="row breadcrumbs-top">
                                    <div class="col-sm-12">
                                        <h2 class="content-header-title float-left mb-0"> Checkpoint Arrival Consolidated Report </h2>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- Bordered table end -->
        </div>
     
        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <form class="dt_adv_search" action="{{ url('/vehicle_tracking_reports/checkpoints_consolidated') }}" method="POST">
                            @csrf
                            <input type="hidden" name="form_type" value="search_frm">
                            <div class="card-header w-100">
                                <div class="row w-100">
                                    <div class="col-sm-10">
                                        <div class="row">
                                            <div class="col-sm-2">
                                                <div class="form-group m-0">
                                                    <label class="form-label">Pakage</label>
                                                    <select class="select2 form-select" id="Pakage_id" name="Pakage_id" onChange="get_wards()">
                                                        <option value="">--- All Pakage ---</option>
                                                        @foreach($Pakages as $val)

                                                            @php $selected = '';   @endphp 
                                                            @if($Pakage_id == $val->id)
                                                            @php $selected ='selected'; @endphp
                                                            @endif
                                                        <option {{ $selected }} value="{{ $val->id }}">{{ $val->Pakage_name }}</option>
                                                        @endforeach 
                                                    </select>
                                                </div>
                                            </div>

                                            <div class="col-sm-2">
                                                <label class="form-label">Wards</label>
                                                <select class="select2 form-select" id="ward_id" name="ward_id" >
                                                    <option value="0">--All Wards--</option>
                                                    @foreach($wards as $val)

                                                        @php $selected = '';  @endphp 
                                                        @if($ward_id == $val->id)
                                                        @php $selected ='selected'; @endphp
                                                        @endif
                                                    <option {{ $selected }} value="{{ $val->id }}">{{ $val->ward_name }}</option>
                                                    @endforeach 
                                                </select>
                                            </div>

                                            <div class="col-sm-2">
                                                <label class="form-label">Vehicle</label>
                                                <select name="vehicle_id" id="vehicle_id" class="select2 form-select">
                                                    <option value="0">--All Vehicles--</option>
                                                    @foreach($vehicle as $val)

                                                        @php $selected = '';  @endphp 
                                                        @if($vehicle_id == $val->id)
                                                        @php $selected ='selected'; @endphp
                                                        @endif
                                                    <option {{ $selected }}  value="{{$val->id}}">{{$val->vehicle_number }}</option>
                                                    @endforeach  
                                                </select>
                                            </div>
                                           
                                            <div class="col-sm-2">
                                                <label class="form-label">Vehicle Type</label>
                                                <select name="vehicle_type_id" id="vehicle_type_id" class="select2 form-select">
                                                    <option value="0">--- All Vehicle Types ---</option>
                                                    @foreach($vehicle_type as $val)

                                                        @php $selected = '';  @endphp 
                                                        @if($vehicle_type_id == $val->id)
                                                        @php $selected ='selected'; @endphp
                                                        @endif
                                                    <option {{ $selected }} value="{{$val->id}}">{{$val->type }}</option>
                                                    @endforeach  
                                                </select>
                                            </div>

                                            <div class="col-sm-2">
                                              <label class="form-label">Date</label>
                                              <input id="date" name="date" class="form-control flatpickr-basic" type="text" value="<?php echo date('d-m-Y',strtotime($date)); ?>" >
                                            </div>

                                            <div class="col-sm-2">
                                                <label class="form-label">&nbsp;</label><br>
                                                    <button type="submit" class="btn btn-primary">Search</button>
                                                    @if ($search) 
                                                      <a title="Clear" href="{{ url('/vehicle_tracking_reports/clear_search/checkpoints_consolidated') }}" type="button" class="btn btn-outline-primary"><i data-feather="rotate-ccw" class="me-25"></i> Clear </a>
                                                    @endif
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-sm-2">
                                       
                                        <label class="form-label">&nbsp;</label><br>
                                            <div class="d-flex align-items-center justify-content-end">
                                                @if(count($records))
                                                    <a title="Clear" href="{{ url('/vehicle_tracking_reports/checkpoints_consolidated/export_excel') }}"  style="margin : 2px;"
                                                    type="button" class="btn btn-outline-primary">
                                                    <i class='fa fa-download' arial-hidden="true"></i> Excel
                                                </a>
                                                @endif
                                                <a href="{{ url('vehicle_tracking_reports') }}" 
                                                    class="btn btn-outline-primary float-right"><span>Back</span></a>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </form>
                        <div class="table-responsive">
                            <table class="table table-striped table-bordered">
                                <thead>
                                    <tr>
                                        <th rowspan="3" style="text-align:center;vertical-align:middle;">Sr. No.</th>
                                        <th rowspan="3" style="text-align:center;vertical-align:middle;">Vehicle Number</th>
                                        <th colspan="15" style="text-align:center;vertical-align:middle;">Checkpoints</th>
                                        <th rowspan="3" style="text-align:center;vertical-align:middle;">Average
                                        </th>	
                                    </tr>
                                    <tr>
                                        <th colspan="3" style="text-align:center;">1st</th>
                                        <th colspan="3" style="text-align:center;">2nd</th>
                                        <th colspan="3" style="text-align:center;">3rd</th>
                                        <th colspan="3" style="text-align:center;">4th</th>
                                        <th colspan="3" style="text-align:center;">5th</th>
                                    </tr>
                                    <tr>
                                        <th style="text-align:center;">Location</th>
                                        <th style="text-align:center;">Expected Time</th>
                                        <th style="text-align:center;">Actual Time</th>
                                        
                                        <th style="text-align:center;">Location</th>
                                        <th style="text-align:center;">Expected Time</th>
                                        <th style="text-align:center;">Actual Time</th>
                                        
                                        <th style="text-align:center;">Location</th>
                                        <th style="text-align:center;">Expected Time</th>
                                        <th style="text-align:center;">Actual Time</th>
                                        
                                        <th style="text-align:center;">Location</th>
                                        <th style="text-align:center;">Expected Time</th>
                                        <th style="text-align:center;">Actual Time</th>
                                        
                                        <th style="text-align:center;">Location</th>
                                        <th style="text-align:center;">Expected Time</th>
                                        <th style="text-align:center;">Actual Time</th>
                                    </tr>

                                </thead>
                                <tbody class="text-left">

                                <?php 
                                    if(!empty($records)){
                                       
                                    // echo '<pre>'; print_r($records); die;
                                       $i = 0;
                                       foreach($records as $aValue){ 
                                           if(!empty($aValue['vehicle_name'])){
                                        $i++;

                                        $missing1 = (!empty($aValue['checkpoints']['first']->actual_reach_time)) ? '' : 'skyblue';
                                        $missing2 = (!empty($aValue['checkpoints']['second']->actual_reach_time)) ? '' : 'skyblue';
                                        $missing3 = (!empty($aValue['checkpoints']['third']->actual_reach_time)) ? '' : 'skyblue';
                                        $missing4 = (!empty($aValue['checkpoints']['fourth']->actual_reach_time)) ? '' : 'skyblue';
                                        $missing5 = (!empty($aValue['checkpoints']['fifth']->actual_reach_time)) ? '' : 'skyblue';
                                        $diff_class_1st = '';
                                        $diff_class_2nd = '';
                                        $diff_class_3rd = '';
                                        $diff_class_4th = '';
                                        $diff_class_5th = '';

                                        if(!empty($aValue['checkpoints']['first']->second_with_sign)){
                                            if($aValue['checkpoints']['first']->second_with_sign > 0)  
                                                $diff_class_1st = 'redtd';
                                            elseif($aValue['checkpoints']['first']->second_with_sign < 0)
                                                $diff_class_1st = 'greentd';   
                                        }  
                                                                
                                        if(!empty($aValue['checkpoints']['second']->second_with_sign)){
                                            if($aValue['checkpoints']['second']->second_with_sign > 0) 
                                                $diff_class_2nd = 'redtd';
                                            elseif($aValue['checkpoints']['second']->second_with_sign < 0)
                                                $diff_class_2nd = 'greentd';
                                            
                                        }
                
                                        if(!empty($aValue['checkpoints']['third']->second_with_sign)){
                                            if($aValue['checkpoints']['third']->second_with_sign > 0)
                                                $diff_class_3rd = 'redtd';
                                            elseif($aValue['checkpoints']['third']->second_with_sign < 0)
                                                $diff_class_3rd = 'greentd';
                                        }
                
                                        if(!empty($aValue['checkpoints']['fourth']->second_with_sign)){
                                            if($aValue['checkpoints']['fourth']->second_with_sign > 0)	
                                                $diff_class_4th = 'redtd';
                                            elseif($aValue['checkpoints']['fourth']->second_with_sign < 0)
                                                $diff_class_4th = 'greentd';
                                        }
                                        
                                        if(!empty($aValue['checkpoints']['fifth']->second_with_sign)){
                                        if($aValue['checkpoints']['fifth']->second_with_sign > 0)	
                                            $diff_class_5th = 'redtd';
                                        elseif($aValue['checkpoints']['fifth']->second_with_sign < 0)
                                            $diff_class_5th = 'greentd'; 
                                        }
                                ?>
                                    <tr>
                                        <td rowspan="2" class="text-center"><?php echo $i; ?></td>
                                        <td rowspan="2" class="text-center"><?php echo $aValue['vehicle_name']; ?></td>
                                        
                                        <!-- First checkpoint -->
                                        <td rowspan="2" class="<?Php echo $missing1.' '.$diff_class_1st ?> border_bottom">
                                        <?php if(!empty($aValue['checkpoints']['first']->location))
								              echo $aValue['checkpoints']['first']->location; ?>
                                        </td>
                                        <td class="<?Php echo $missing1.' '.$diff_class_1st ?>"><?php
                                            if(!empty($aValue['checkpoints']['first']->expected_time))  
                                                echo date('h:i A',strtotime($aValue['checkpoints']['first']->expected_time)); ?>
                                        </td>
                                        <td class="<?Php echo $missing1.' '.$diff_class_1st ?>"><?php
                                            if(!empty($aValue['checkpoints']['first']->actual_reach_time))echo $aValue['checkpoints']['first']->actual_reach_time; ?>
                                        </td>

                                        <!-- Second checkpoint -->
                                        <td rowspan="2" class="<?Php echo $missing2.' '.$diff_class_2nd ?>  border_bottom"><?php 
                                            if(!empty($aValue['checkpoints']['second']->location))
                                                echo $aValue['checkpoints']['second']->location; ?>
                                        </td>
                                        <td class="<?Php echo $missing2.' '.$diff_class_2nd ?>"><?php
                                            if(!empty($aValue['checkpoints']['second']->expected_time))
                                                echo date('h:i A',strtotime($aValue['checkpoints']['second']->expected_time));
                                                ?>
                                        </td>
                                        <td class="<?Php echo $missing2.' '.$diff_class_2nd ?>"><?php
                                            if(!empty($aValue['checkpoints']['second']->actual_reach_time))
								            echo $aValue['checkpoints']['second']->actual_reach_time; ?>
                                        </td>

                                        <!-- Third checkpoint -->
                                        <td rowspan="2" class="<?Php echo $missing3.' '.$diff_class_3rd ?>  border_bottom"><?php 
                                            if(!empty($aValue['checkpoints']['third']->location))
                                                echo $aValue['checkpoints']['third']->location; ?>
                                        </td>
                                        <td class="<?Php echo $missing3.' '.$diff_class_3rd ?>"><?php 
                                            if(!empty($aValue['checkpoints']['third']->expected_time))
                                                echo date('h:i A',strtotime($aValue['checkpoints']['third']->expected_time));
                                                ?>
                                        </td>
                                        <td class="<?Php echo $missing3.' '.$diff_class_3rd ?>"><?php 
                                            if(!empty($aValue['checkpoints']['third']->actual_reach_time))
								            echo $aValue['checkpoints']['third']->actual_reach_time; ?>
                                        </td>
                                        
                                        <!-- Fourth checkpoint -->
                                        <td rowspan="2" class="<?Php echo $missing4.' '.$diff_class_4th ?>  border_bottom"><?php
                                            if(!empty($aValue['checkpoints']['fourth']->location))
                                                echo $aValue['checkpoints']['fourth']->location; ?>
                                        </td>
                                        <td class="<?Php echo $missing4.' '.$diff_class_4th ?>"><?php
                                            if(!empty($aValue['checkpoints']['fourth']->expected_time))
                                                echo date('h:i A',strtotime($aValue['checkpoints']['fourth']->expected_time));
                                            ?>
                                        </td>
                                        <td class="<?Php echo $missing4.' '.$diff_class_4th ?>"><?php
                                            if(!empty($aValue['checkpoints']['fourth']->actual_reach_time))
								            echo $aValue['checkpoints']['fourth']->actual_reach_time; ?>
                                        </td>

                                        <!-- Firft checkpoint -->
                                        <td rowspan="2" class="<?Php echo $missing5.' '.$diff_class_5th ?>  border_bottom"><?php
                                            if(!empty($aValue['checkpoints']['fifth']->location))
                                            echo $aValue['checkpoints']['fifth']->location; ?>
                                        </td>
                                        <td class="<?Php echo $missing5.' '.$diff_class_5th ?>"><?php
                                            if(!empty($aValue['checkpoints']['fifth']->expected_time))
                                            echo date('h:i A',strtotime($aValue['checkpoints']['fifth']->expected_time));
                                            ?>
                                        </td>
                                        <td class="<?Php echo $missing5.' '.$diff_class_5th ?>"><?php
                                            if(!empty($aValue['checkpoints']['fifth']->actual_reach_time))
                                            echo $aValue['checkpoints']['fifth']->actual_reach_time; ?>
                                        </td>

                                        <!-- next field -->
						                <td rowspan="2" class="border_bottom"><?php echo $aValue['average']; ?>
                                        </td>

                                    </tr> 

                                    <tr>
                                        <td colspan="2" class="<?Php echo $missing1.' '.$diff_class_1st ?> border_bottom" style="text-align:center;">
                                            <?php
                                            if(!empty($aValue['checkpoints']['first']->time_difference))	
                                                echo $aValue['checkpoints']['first']->time_difference; ?>
                                        </td>

                                        <td colspan="2" class="<?Php echo $missing2.' '.$diff_class_2nd ?> border_bottom" style="text-align:center;">
                                            <?php
                                            if(!empty($aValue['checkpoints']['second']->time_difference))	
                                                echo $aValue['checkpoints']['second']->time_difference; ?>
                                        </td>

                                        <td colspan="2" class="<?Php echo $missing3.' '.$diff_class_3rd ?> border_bottom" style="text-align:center;">
                                            <?php
                                            if(!empty($aValue['checkpoints']['third']->time_difference))	
                                                echo $aValue['checkpoints']['third']->time_difference; ?>
                                        </td>

                                        <td colspan="2" class="<?Php echo $missing4.' '.$diff_class_4th ?> border_bottom"  style="text-align:center;">
                                            <?php
                                            if(!empty($aValue['checkpoints']['fourth']->time_difference))	
                                                echo $aValue['checkpoints']['fourth']->time_difference; ?>
                                        </td>
                                        
                                        <td colspan="2" class="<?Php echo $missing5.' '.$diff_class_5th ?> border_bottom" style="text-align:center;">
                                            <?php
                                            if(!empty($aValue['checkpoints']['fifth']->time_difference))	
                                                echo $aValue['checkpoints']['fifth']->time_difference; ?>
                                        </td>
                                    </tr>

                                    <?php
                                           
                                       } 
                                   }}else{ ?>

                                    <tr>
                                        <td colspan="20" class="text-center" style="color:red;">No Record Found.</td>
                                    </tr>
                                   <?php } ?>
                                </tbody>
                            </table>
                            <div class="card-body">
                                <div class="d-flex justify-content-end">
                                   <!-- Pagination code -->
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
            <!-- Bordered table end -->
        </div>
    </section>
@endsection

<script src="https://code.jquery.com/jquery-3.6.0.min.js" integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>

<script>
	function get_wards(){
		var Pakage_id = $('#Pakage_id').val();
        $.ajax({
                type: "post",
                url: "{{ url('/route_master/wards') }} ",
                data:{"_token": "{{ csrf_token() }}","Pakage_id":Pakage_id},
                success: function(response){
                  // alert(response);
                   $('#ward_id').html(response); 
                },
                error: function(){						
                    alert("Error while request..");
                }
        });
		
    }
</script>
