@extends('layout.index')
@section('title', 'Vehicle OverSpeed Report ')

<!-- Dashboard Ecommerce start -->
@section('content')
    @php
    use Carbon\Carbon;
    @endphp
    <section>
        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header w-100">
                            <div class="content-header-left">
                                <div class="row breadcrumbs-top">
                                    <div class="col-sm-12">
                                        <h2 class="content-header-title float-left mb-0"> Vehicle Overspeed Report </h2>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- Bordered table end -->
        </div>
     
        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <form class="dt_adv_search" action="{{ url('/vehicle_tracking_reports/vehicle_overspeed') }}" method="POST">
                            @csrf
                            <input type="hidden" name="form_type" value="search_frm">
                            <div class="card-header w-100">
                                <div class="row w-100">
                                    <div class="col-sm-10">
                                        <div class="row">

                                            <div class="col-sm-2">
                                                <label class="form-label">Vehicle</label>
                                                <select name="vehicle_id" id="vehicle_id" class="select2 form-select">
                                                    <option value="">--All Vehicles--</option>
                                                    @foreach($aVehicles as $val)

                                                        @php $selected = '';  @endphp 
                                                        @if($vehicle_id == $val->id)
                                                        @php $selected ='selected'; @endphp
                                                        @endif
                                                    <option {{ $selected }}  value="{{$val->id}}">{{$val->vehicle_number }}</option>
                                                    @endforeach  
                                                </select>
                                                <h5><small class="text-danger" id="vehicle_id_err"></small></h5>
                                            </div>
                                            <div class="col-sm-3">
                                                <label class="form-label">Start Date</label>
                                                <input id="start_date" name="start_date" class="form-control flatpickr-basic" type="text" 
                                                value="<?php echo $start_date; ?>"
                                                 >
                                              </div>
  
                                              <div class="col-sm-3">
                                                <label class="form-label">End Date</label>
                                                <input id="end_date" name="end_date" class="form-control flatpickr-basic" type="text"   
                                                
                                                value="<?php echo $end_date; ?>"
                                                 >
                                              </div>
  
  
                                            <div class="col-sm-4">
                                                <label class="form-label">&nbsp;</label><br>
                                                    <button type="submit" class="btn btn-primary">Search</button>
                                                    @if ($search) 
                                                      <a title="Clear" href="{{ url('/vehicle_tracking_reports/clear_search/vehicle_overspeed') }}" type="button" class="btn btn-outline-primary"><i data-feather="rotate-ccw" class="me-25"></i> Clear </a>
                                                    @endif
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-sm-2">
                                        
                                        <label class="form-label">&nbsp;</label>
                                        <div class="d-flex align-items-center justify-content-end">
                                        @if(count($aOverspeed))
                                            <a title="Clear" href="{{ url('/vehicle_tracking_reports/vehicle_overspeed/export_excel') }}"  style="margin: 4px;"
                                                type="button" class="btn btn-outline-primary">
                                                <i class='fa fa-download' arial-hidden="true"></i> Excel
                                            </a>
                                        @endif        
                                            <a href="{{ url('vehicle_tracking_reports') }}" 
                                                    class="btn btn-outline-primary float-right"><span>Back</span></a>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </form>
                        <div class="table-responsive">
                            <table class="table table-striped table-bordered">
                                <thead>
                                    <tr>
                                        <th class="text-center">Sr.No</th>
                                        <th>Vehicle Number</th>
                                        <th>Date</th>
                                        <th>Time</th>
                                        <th class="text-center">Speed</th>
                                    </tr>
                                </thead>
                                <tbody class="text-left">
                                    @if($aOverspeed)
                                     @if(count($aOverspeed))
                                        @php
                                            $i = 0;
                                        @endphp
                                        @foreach ($aOverspeed as $val)
                                        @php   $counter = 0;  
                                            $p = 0;
                                            $datetime_count = count($val['all_data']["datetime"]);
                                        @endphp
                                        
                                            @foreach($val['all_data']["speed"] as $value)
                                                @php 
                                                    $rowSpan = count($val['all_data']["speed"]);
                                                   
                                                @endphp
                                                <tr>
                                                    @if($counter == 0)
                                                        @php
                                                            $i++;
                                                            $counter ++;
                                                         @endphp
                                                        <td rowspan="{{ $rowSpan }}" class="text-center">{{ $i }}</td>
                                                        <td rowspan="{{ $rowSpan }}" > {{ $val['vehicle_number'] }}</td>
                                                    @endif
                                                    @if($p <= $datetime_count)
                                                        <td>{{ date('d-m-Y', $val['all_data']["datetime"][$p]) }}</td>
                                                        <td>{{  date('h:i:s', $val['all_data']["datetime"][$p]) }}</td>
                                                        @php $p++ @endphp
                                                    @endif
                                                    <td class="text-center">{{ $value }}</td>
                                                </tr>
                                            @endforeach
                                        @endforeach
                                    @else
                                        <tr>
                                            <td colspan="16" style="text-align: center; color:red;">No Record Found.</td>
                                        </tr>
                                    @endif
                                    @endif
                                </tbody>
                            </table>
                            <div class="card-body">
                                <div class="d-flex justify-content-end">
                                    {{ $aOverspeed->links() }}
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
            <!-- Bordered table end -->
        </div>
    </section>
@endsection
