@extends('layout.index')
@section('title', 'Vehicle Type-wise Weight Management Report')

<!-- Dashboard Ecommerce start -->
@section('content')
    @php
    use Carbon\Carbon;
    @endphp
    <section>
        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header w-100">
                            <div class="content-header-left">
                                <div class="row breadcrumbs-top">
                                    <div class="col-sm-12">
                                        <h2 class="content-header-title float-left mb-0">Vehicle Type-wise Weight Management Report </h2>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- Bordered table end -->
        </div>
     
        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <form class="dt_adv_search" action="{{ url('/vehicle_tracking_reports/vehicle_type_wise_weight_mngmt') }}" method="POST">
                            @csrf
                            <input type="hidden" name="form_type" value="search_frm">
                            <div class="card-header w-100">
                                <div class="row w-100">
                                    <div class="col-sm-7">
                                        <div class="row">
                                            <div class="form-group m-0">
                                                <label class="form-label">Pakage</label>
                                                <select class="select2 form-select" id="Pakage_id" style="width:200px !important" name="Pakage_id">
                                                    <option value="">--- All Pakage ---</option>
                                                    @foreach($Pakages as $val)

                                                        @php $selected = '';   @endphp 
                                                        @if($Pakage_id == $val->id)
                                                        @php $selected ='selected'; @endphp
                                                        @endif
                                                    <option {{ $selected }} value="{{ $val->id }}">{{ $val->Pakage_name }}</option>
                                                    @endforeach 
                                                </select>
                                            </div>
                                            <div class="col-sm-2">
                                              <label class="form-label">Start Date</label>
                                              <input id="start_date" name="start_date" class="form-control flatpickr-basic" type="text" value="<?php echo $start_date; ?>" >
                                            </div>

                                            <div class="col-sm-2">
                                              <label class="form-label">End Date</label>
                                              <input id="end_date" name="end_date" class="form-control flatpickr-basic" type="text" value="<?php echo $end_date; ?>" >
                                            </div>

                                            <div class="col-sm-2">
                                              <label class="form-label">Vehicle Type</label>
                                              <select name="vehicle_type" id="vehicle_type" class="form-control">
                                                <option value="">-- All Type --</option>
                                                <option value="10" <?php if($vehicle_type == 10){ echo 'selected'; } ?>>Door to Door</option>
                                                <option value="4" <?php if($vehicle_type == 4){ echo 'selected'; } ?>>Garden</option>
                                                <option value="5" <?php if($vehicle_type == 5){ echo 'selected'; } ?>>Debris</option>
                                              </select>
                                            </div>


                                            <div class="col-sm-3">
                                                <label class="form-label">&nbsp;</label><br>
                                                <div  style="display: flex; align-items: center;">
                                                    <button type="submit" class="btn btn-primary mr-1" onClick="return validation()">Search</button>
                                                    @if ($search) 
                                                      <a title="Clear" href="{{ url('/vehicle_tracking_reports/clear_search/vehicle_type_wise_weight_mngmt') }}" type="button" class="btn btn-outline-primary"><i data-feather="rotate-ccw" class="me-25"></i> Clear </a>
                                                    @endif
                                                    </div>
                                            </div>
                                            
                                        </div>
                                    </div>
                                    <div class="col-sm-5" style="float:right;"> 
                                        <label class="form-label">&nbsp;</label><br>
                                        <div class="d-flex align-items-center justify-content-end">
                                        @if(count($records))       
                                            <a href="{{ url('/vehicle_tracking_reports/vehicle_type_wise_weight_pdf/export_pdf') }}" 
                                            class="btn btn-outline-primary" style="margin :3px;float:right;"><i class='fa fa-file-pdf-o' arial-hidden="true" ></i> Type Wise Weight PDF</a>

                                            <!-- summary -->
                                            <a href="{{ url('/vehicle_tracking_reports/vehicle_type_summary_weight_pdf/export_pdf') }}" 
                                            class="btn btn-outline-primary" style="margin :3px; float:right;" ><i class='fa fa-file-pdf-o' arial-hidden="true" ></i> Total Weight PDF</a>

                                            <a title="Clear" href="{{ url('/vehicle_tracking_reports/vehicle_type_wise_weight_mngmt/export_excel') }}"  style="margin :3px; float:right;" type="button" class="btn btn-outline-primary"><i class='fa fa-download' arial-hidden="true"></i> Excel
                                            </a>
                                        @endif   
                                            <a href="{{ url('vehicle_tracking_reports') }}" 
                                                    class="btn btn-outline-primary" style="margin :3px; float:right;"><span>Back</span></a>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </form>
                      
                       
                        <div class="table-responsive">
                           
                            <table class="table table-striped table-bordered">
                                <thead>
                                    <tr>
                                        <th class="text-center">Sr.No</th>
                                        <th class="text-left">Date</th>
                                        <th class="text-center">Total Net Weight
                                       <span style="color:#8c82f3;"> <?php 
                                            if($vehicle_type == 10){
                                                echo '(Door to Door)';
                                            }elseif($vehicle_type == 4){
                                                echo '(Garden)';
                                            }elseif($vehicle_type == 5){
                                                echo '(Debris)';  
                                            }else{
                                                echo '(Door to Door / Garden / Debris)';
                                            }
                                        ?> </span>
                                        </th>
                                        <th class="text-center">Tons</th>
                                    </tr>
                                </thead>
                                <tbody class="text-left">
                               
                                <?php 
                               // echo '<pre>'; print_r($records); die;
                                   if(!empty($records)){
                                        $i = 0;
                                        $total_weight_tons  = 0;
                                        $grand_total_weight = 0;
                                        foreach($records as $aValue){ 
                                        $i++;
                                        
                                        $grand_total_weight += $aValue['net_weight'];
                                        $total_weight_tons = ($aValue['net_weight']/1000);    
                                ?>
                                    <tr>
                                        <td class="text-center"><?php echo $i; ?></td>
                                        <td class="text-left"><?php echo $aValue['date']; ?></td>
                                        <td class="text-center"><?php echo $aValue['net_weight']; ?>
                                        <td class="text-center"><?php echo $total_weight_tons; ?></td>
                                        </td>
                                    </tr>	


                                    <?php } ?> 
                                        <tr>
                                            <th class="text-right" colspan="2">Total</th>
                                            <th class="text-center"><?php echo $grand_total_weight; ?></th>
                                            <th class="text-center"><?php echo ($grand_total_weight/1000); ?></th>
                                        </tr>
                                    <?php }else{ ?>

                                    <tr>
                                        <td colspan="7" class="text-center" style="color:red;">No Record Found.</td>
                                    </tr>
                                   
                                    <?php } ?>
                                     
                                </tbody>
                            </table>
                            <div class="card-body">
                                <div class="d-flex justify-content-end">
                                    <!-- pagination code -->
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
            <!-- Bordered table end -->
        </div>
    </section>
@endsection

