@extends('layout.index')
@section('title', 'Weight Management - Payable Amount Report')

<!-- Dashboard Ecommerce start -->
@section('content')
    @php
    use Carbon\Carbon;
    @endphp
   
    <section>
        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header w-100">
                            <div class="content-header-left">
                                <div class="row breadcrumbs-top">
                                    <div class="col-sm-12">
                                        <h2 class="content-header-title float-left mb-0">Weight Management - Payable Amount Report</h2>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- Bordered table end -->
        </div>
     
        <div class="content-body">
            <!-- Bordered table start -->
            <?php setlocale(LC_MONETARY, 'en_IN'); ?>
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <form class="dt_adv_search" action="{{ url('/vehicle_tracking_reports/weight_mngt_payable_amt') }}" method="POST">
                            @csrf
                            <input type="hidden" name="form_type" value="search_frm">
                            <div class="card-header w-100">
                                <div class="row w-100">
                                    <div class="col-sm-10">
                                        <div class="row">
                                            <div class="col-sm-2">
                                                <label class="form-label">Pakage</label>
                                               <select class="select2 form-select" id="Pakage_id" name="Pakage_id">
                                                    <option value="">--- All Pakage ---</option>
                                                    @foreach($Pakages as $val)

                                                        @php $selected = '';   @endphp 
                                                        @if($Pakage_id == $val->id)
                                                        @php $selected ='selected'; @endphp
                                                        @endif
                                                    <option {{ $selected }} value="{{ $val->id }}">{{ $val->Pakage_name }}</option>
                                                    @endforeach 
                                                </select>
                                                <h5><small class="text-danger" id="Pakage_id_err"></small></h5>
                                            </div>

                                           @php 
                                                $current_year = date('Y',strtotime('now')); 
                                                $new_year = array();
                                                foreach($aYears as $key=>$val){
                                                    if($val <= $current_year){
                                                        $new_year[$key] = $val;
                                                    }
                                                }
                                               $new_month = array();


                                                $current_month = date('m',strtotime('now')); 
                                                $new_month = array();
                                                foreach($aMonths as $key=>$val){
                                                        if($key <=  $current_month){
                                                            $new_month[$key] = $val;
                                                        }
                                                }

                                                $current_day = date('d',strtotime('now')); 
                                                $new_day = array();
                                                foreach($aDays as $key=>$val){
                                                    if($key <= 9){

                                                        $new_key ='0'.$key.'';
                                                        if($new_key <=  $current_day){
                                                            $new_day[$key] = $val;
                                                        }
                                                    }
                                                    if($key > 9){
                                                        if($key <=  $current_day){
                                                            $new_day[$key] = $val;
                                                        }
                                                    }
                                                }
                                                // dd($month);
                                            @endphp
                                            
                                            <div class="col-sm-2">
                                                <label class="form-label">Year</label>
                                                <select class="select2 form-select" id="year" name="year" onchange="changeyear();">
                                                    <option value="">--- All Year ---</option>
                                                    @foreach($new_year as $key => $value)

                                                        @php $selected = '';   @endphp 
                                                        @if($year == $key)
                                                        @php $selected ='selected'; @endphp
                                                        @endif
                                                    <option {{ $selected }} value="{{ $key }}">{{ $value }}</option>
                                                        @endforeach 
                                                </select>
                                            </div>
                                            <div class="col-sm-2">
                                                <label class="form-label">Month</label>
                                                <select class="select2 form-select" id="month" name="month"  onchange="changemonth();">
                                                    <option value="">--- All Month ---</option> 
                                                    @if($month ==  $current_month && $year == $current_year)
                                                        @foreach($new_month as $key => $value)
                                                            @php   $selected = '';   @endphp 
                                                            @if($month == $key)
                                                                @php $selected ='selected'; @endphp
                                                            @endif
                                                            <option {{ $selected }} value="{{ $key }}">{{ $value }}</option>
                                                        @endforeach 
                                                    @else
                                                        @foreach($aMonths as $key => $value)
                                                            @php   $selected = '';   @endphp 
                                                            @if($month == $key)
                                                                @php $selected ='selected'; @endphp
                                                            @endif
                                                            <option {{ $selected }} value="{{ $key }}">{{ $value }}</option>
                                                        @endforeach 
                                                    @endif                                                       
                                                </select>
                                            </div>
                                            <div class="col-sm-2">
                                                <label class="form-label">Start Day</label>
                                                <select class="select2 form-select" id="start_day" name="start_day">
                                                    <option value="">--- All Start Day ---</option>
                                                    @foreach($aDays as $key => $value)

                                                        @php $selected = '';   @endphp 
                                                        @if($start_day == $key)
                                                        @php $selected ='selected'; @endphp
                                                        @endif
                                                    <option {{ $selected }} value="{{ $key }}">{{ $value }}</option>
                                                    @endforeach 
                                                </select>
                                            </div>

                                            <div class="col-sm-2">
                                                <label class="form-label">End Day</label>
                                                <select class="select2 form-select" id="end_day" name="end_day">
                                                    <option value="">--- All End Day ---</option>
                                                        @if($end_day ==  $current_day && $month ==$current_month && $year == $current_year)
                                                            @foreach($new_day as $key => $value)

                                                                @php $selected = '';   @endphp 
                                                                @if($end_day == $key)
                                                                    @php $selected ='selected'; @endphp
                                                                @endif
                                                                <option {{ $selected }} value="{{ $key }}">{{ $value }}</option>
                                                            @endforeach 
                                                        @else
                                                            @foreach($aDays as $key => $value)
                                                                @php $selected = '';   @endphp 
                                                                @if($end_day == $key)
                                                                    @php $selected ='selected'; @endphp
                                                                @endif
                                                                <option {{ $selected }} value="{{ $key }}">{{ $value }}</option>
                                                            @endforeach 
                                                        @endif
                                                </select>
                                            </div>                                          

                                            <div class="col-sm-2">
                                                <label class="form-label">&nbsp;</label><br>
                                                    <button type="submit" class="btn btn-primary" onClick="return validation()">Search</button>
                                                    @if ($search) 
                                                      <a title="Clear" href="{{ url('/vehicle_tracking_reports/clear_search/weight_mngt_payable_amt') }}" type="button" class="btn btn-outline-primary"><i data-feather="rotate-ccw" class="me-25"></i> clear </a>
                                                    @endif
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-sm-2">
                                        <div class = "mt-2" style="float:right;">
                                         <?php  if(count($records['data'])){ ?>
                                            <a title="Clear" href="{{ url('/vehicle_tracking_reports/weight_mngt_payable_amt/export_excel') }}"  style="margin : 2px;"
                                                type="button" class="btn btn-outline-primary">
                                                <i class='fa fa-download' arial-hidden="true"></i> Excel
                                            </a>
                                        <?php } ?>    
                                            <a href="{{ url('vehicle_tracking_reports') }}" 
                                            class="btn btn-outline-primary"><span>Back</span></a>

                                        </div>
                                    </div>

                                    {{-- <div class="col-sm-2" style="float:right;">
                                        <div class="mt-2" >
                                            
                                                
                                    <div class="col-sm-1" style="float:right;">
                                        <div class="col-sm-12" >
                                            <label class="form-label">&nbsp;</label><br>
                                                                                   </div>
                                    </div> --}}
                                </div>
                            </div>
                        </form>
                        <div class="table-responsive">
                            <table class="table table-striped table-bordered">
                                <thead>
                                    <tr>
                                        <th class="text-center">Sr.No</th>
                                        <th class="text-center">Date</th>
                                        <th class="text-center">Loaded Weight</th>
                                        <th class="text-center">Unloaded Weight</th>
                                        <th class="text-center">Net Weight</th>
                                        <th class="text-center">Ton's</th>
                                        <th class="text-center pay-amt-td">Payable Amount</th>
                                        <th class="text-center">Vehicle Absent Fine</th>
                                        <th class="text-center">Biometric Attendance Fine</th>
                                        <th class="text-center">Failed Checkpoint's Fine</th>
                                        <th class="text-center">Time Deviation (Checkpoint's) Fine</th>
                                        <th class="text-center">Deviation Fine</th>
                                        <th class="text-center pay-amt-td">Total Fine</th>
                                        <th class="text-center">Net Payable Amount</th>
                                    </tr>
                                </thead>
                                <tbody class="text-left">
                               
                                <?php 
                                   if(!empty($records['data'])){
                                      $i = 0;
                                      foreach($records['data'] as $aValue){ 
                                      $i++;	
                                      $absentFine = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $aValue['absentFine']);
                                      $missing_employeesFine = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $aValue['missing_employeesFine']);
                                      $chekpointFine = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $aValue['chekpointFine']);
                                      $chekpointFine_time_deviation = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $aValue['chekpointFine_time_deviation']);
                                      $deviation_fine = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $aValue['deviation_fine']);
                                ?>
                                    <tr>
                                        <td class="text-center"><?php echo $i; ?></td>
                                        <td class="text-center"><?php echo date('d-m-Y',strtotime($aValue['current_day'])); ?></td>
                                        <td class="text-center"><?php echo $aValue['total_loaded']; ?></td>
                                        <td class="text-center"><?php echo $aValue['total_unloaded']; ?></td>
                                        <td class="text-center"><?php echo $aValue['total_net']; ?></td>
                                        <td class="text-center"><?php echo $aValue['tons']; ?></td>
                                        <td class="pay-amt-td"><?php echo $aValue['payable_amount']; ?></td>
                                        <td class="text-center"><?php echo $absentFine; ?></td>
                                        <td class="text-center"><?php echo $missing_employeesFine; ?></td>
                                        <td class="text-center"><?php echo $chekpointFine; ?></td>
                                        <td class="text-center"><?php echo $chekpointFine_time_deviation; ?></td>
                                        <td class="text-center"><?php echo $deviation_fine; ?></td>
                                        <td class="text-center pay-amt-td"><?php echo $aValue['total_fine_amount']; ?></td>
                                        <td class="text-center"><?php echo $aValue['net_payable_amount']; ?></td>
                                    </tr> 
                                   <?php } ?>
                                    <tr class="b-top-custom">
                                        <th colspan="5" class="text-center">Total</th>
                                        <th class="text-center"><?php echo $records['total']['total_tons']; ?></th>
                                        <th class="text-center pay-amt-td"><?php echo $records['total']['total_payable_amt'];; ?></th>
                                        <th class="text-center"><?php echo $records['total']['total_absentFine']; ?></th>
                                        <th class="text-center"><?php echo $records['total']['total_missing_employeesFine']; ?></th>
                                        <th class="text-center"><?php echo $records['total']['total_chekpointFine']; ?></th>
                                        <th class="text-center"><?php echo $records['total']['total_chekpointFine_time_deviation']; ?></th>
                                        <th class="text-center"><?php echo $records['total']['total_deviation_fine']; ?></th>
                                        <th class="text-center pay-amt-td"><?php echo $records['total']['total_fine']; ?></th>
                                        <th class="text-center"><?php echo $records['total']['total_net_payable_amount'];
                                        ?></th>
                                        
                                    </tr>
                                   <?php }else{ ?>
                                    <tr>
                                        <td colspan="14" class="text-center" style="color:red;">No Record Found</td>
                                    </tr>
                                   <?php } ?>
                                   
                                </tbody>
                            </table>
                            <div class="card-body">
                                <div class="d-flex justify-content-end">
                                   <!-- pagination code -->
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
            <!-- Bordered table end -->
        </div>
    </section>
@endsection

<script type="text/javascript">
	function validation() {
 
      if ($('#Pakage_id').val() == ""){
         $('#Pakage_id').parent().addClass('has-error');
         $('#Pakage_id_err').html('Please Select Pakage.');
         $('#Pakage_id').focus();
         $('#Pakage_id').change(function () {
         $('#Pakage_id').parent().removeClass('has-error');
         $('#Pakage_id_err').html('');
        });
        return false;
      }
    }  
	
    function changeyear(){
        year = $('#year').val();
        end_day = $('#end_day').val();

        var currentTime = new Date();
        var current_year = currentTime.getFullYear();

        $.ajax({
                type: "post",
                url: "{{ url('/vehicle_tracking_reports/weight_mngt_payable_amt/get_month') }} ",
                data:{
                    "_token": "{{ csrf_token() }}",
                    "year":year,
                    "current_year":current_year,
                    "end_day":end_day
                },
                success: function(response){
                   $('#month').html(response[0]); 
                   $('#end_day').html(response[1]); 
                },
                error: function(){						
                    alert("Error while request..");
                }
        });
    }	

    function changemonth(){
        year = $('#year').val();
        month = $('#month').val();
        $.ajax({
                type: "post",
                url: "{{ url('/vehicle_tracking_reports/weight_mngt_payable_amt/get_day') }} ",
                data:{
                    "_token": "{{ csrf_token() }}",
                    "year":year,
                    "month":month
                },
                success: function(response){
                   $('#end_day').html(response); 
                },
                error: function(){						
                }
        });
    }	
    	    
</script>

