@extends('layout.index')
@section('title', 'Verify Vehicle Weight Report')

<!-- Dashboard Ecommerce start -->
@section('content')
    @php
    use Carbon\Carbon;
    @endphp
    <section>
        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header w-100">
                            <div class="content-header-left">
                                <div class="row breadcrumbs-top">
                                    <div class="col-sm-12">
                                        <h2 class="content-header-title float-left mb-0">Verify Vehicle Weight Report </h2>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- Bordered table end -->
        </div>

        <?php if($message = Session::get('success')){ ?>
            <div class="demo-spacing-0 mb-1">
                <div class="alert alert-success alert-dismissible fade show" role="alert">
                    <div class="alert-body">
                        <i class="fa fa-check-circle" style="font-size:16px;" aria-hidden="true"></i>
                            {{ $message }}
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close">

                    </div>
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                    </button>
                </div>
            </div>
        <?php }elseif($message = Session::get('error')){
        ?>
           <div class="demo-spacing-0 mb-1">
                    <div class="alert alert-danger alert-dismissible fade show" role="alert">
                        <div class="alert-body">
                            <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                                {{ $message }}
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">

                        </div>
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
           </div>
        <?php } ?>

        <div class="content-body">
            <!-- Bordered table start -->
            <div class="row" id="table-bordered">
                <div class="col-12">
                    <div class="card">
                        <form class="dt_adv_search" action="{{ route('verify_weight_report.search') }}" method="POST">
                            @csrf
                            <input type="hidden" name="form_type" value="search_frm">
                            <div class="card-header w-100">
                                <div class="row w-100">
                                    <div class="col-sm-10">
                                        <div class="row">
                                            <div class="col-sm-2">
                                                <div class="form-group m-0">
                                                    <label class="form-label">Division</label>
                                                    <select class="select2 form-select" id="division_id" name="division_id">
                                                        <option value="">--- All Division ---</option>
                                                        @foreach($divisions as $val)

                                                            @php $selected = '';   @endphp 
                                                            @if($division_id == $val->id)
                                                            @php $selected ='selected'; @endphp
                                                            @endif
                                                        <option {{ $selected }} value="{{ $val->id }}">{{ $val->division_name }}</option>
                                                        @endforeach 
                                                    </select>
                                                </div>
                                            </div>

                                            <div class="col-sm-2">
                                                <label class="form-label">Vehicle</label>
                                                <select name="vehicle_id" id="vehicle_id" class="select2 form-select">
                                                    <option value="0">--All Vehicles--</option>
                                                    @foreach($vehicle as $val)

                                                        @php $selected = '';  @endphp 
                                                        @if($vehicle_id == $val->id)
                                                        @php $selected ='selected'; @endphp
                                                        @endif
                                                    <option {{ $selected }}  value="{{$val->id}}">{{$val->vehicle_number }}</option>
                                                    @endforeach  
                                                </select>
                                            </div>
                                           
                                            <div class="col-sm-2">
                                              <label class="form-label">Date</label>
                                              <input id="date" name="date" class="form-control flatpickr-basic" type="text" value="<?php echo date('d-m-Y',strtotime($date)); ?>" >
                                            </div>

                                            <div class="col-sm-3">
                                                <label class="form-label">&nbsp;</label><br>
                                                    <button type="submit" class="btn btn-primary">Search</button>
                                                    @if ($search) 
                                                      <a title="Clear" href="{{ url('/verify_weight_report/clear_search') }}" type="button" class="btn btn-icon btn-outline-primary"><i data-feather='x'></i> clear </a>
                                                    @endif
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-sm-2">
                                        <div class="col-sm-12" >
                                            <label class="form-label">&nbsp;</label><br>
                                            <!-- <a title="Clear" href="{{ url('/vehicle_tracking_reports/daily_weight_mngmt/export_excel') }}"  style="margin : 2px;"
                                                type="button" class="btn btn-icon btn-outline-primary">
                                                <i class='fa fa-download' arial-hidden="true"></i>Excel
                                            </a> -->
                                            <!-- <a href="{{ url('vehicle_tracking_reports') }}" 
                                                class="btn btn-outline-primary "><span>Back</span></a> -->
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </form>
                        <div class="table-responsive">
                         <form action="{{ url('/verify_weight_report/verify_weight') }}" method="POST" >
                            @csrf
                            <input type="hidden" name="form_type" value="submit_frm">

                            <table class="table table-striped table-bordered">
                                <thead>
                                    <tr>
                                        <th class="text-center">
                                        <input type="checkbox" onClick="selectall(this)"/> Select All<br/>
                                        </th>
                                        <th class="text-center">Sr.No</th>
                                        <th class="text-left">Time</th>
                                        <th class="text-left">Vehicle Number</th>
                                        <th class="text-left">Loaded Weight</th>
                                        <th class="text-left">Unloaded Weight</th>
                                        <th class="text-left">Net Weight</th>
                                        <th class="text-center">Action</th>
                                    </tr>
                                </thead>
                                <tbody class="text-left">
                               
                                <?php 
                                   if(!empty($weightData)){
                                    // echo '<pre>'; print_r($weightData['total']); die;
                                        $i = 0;
                                        $total_loaded = 0;
                                        $total_unloaded = 0;
                                        $total_net = 0;
                                        
                                        $i = $weightData->perPage() * ($weightData->currentPage() - 1);
                                        foreach($weightData as $aRec){ 

                                            $i++;
                                            $total_loaded += $aRec->loaded_weight;
                                            $total_unloaded += $aRec->unloaded_weight;
                                            $total_net += $aRec->net_weight;
                                       
                                ?>
                                    <tr>
                                        <td class="text-center">
                                           <!-- <input type="text" name="weight_id" id="weight_id" value="<?php //echo $aRec->id  ?>"> -->
                                           <input type="checkbox" name="verify_weight[]" id="verify_weight<?php echo $aRec->id  ?>" value="<?php echo $aRec->id  ?>">
                                        </td>
                                        <td class="text-center"><?php echo $i; ?></td>
                                        <td class="text-left"><?php echo date('h:i a',$aRec->timestamp); ?></td>
                                        <td class="text-left"><?php echo $aRec->vehicle_number ?></td>
                                        <td class="text-left"><?php echo $aRec->loaded_weight ?></td>
                                        <td class="text-left"><?php echo $aRec->unloaded_weight ?></td>
                                        <td class="text-left"><?php echo $aRec->net_weight ?></td>
                                        <td class="text-center">
                                          
                                            <button type="button" class="btn btn-outline-success" data-toggle="modal" data-target="#success" onclick="accept_weight({{ $aRec->id }});">
                                              <i class="fa fa-check" aria-hidden="true"></i> Accept
                                            </button>


                                            <button type="button" class="btn btn-outline-danger" data-toggle="modal" data-target="#danger" onclick="rejected_weight({{ $aRec->id }});">
                                               <i class="fa fa-times" aria-hidden="true"></i> Reject
                                            </button>

                                        </td>
                                   
                                    </tr> 
                                    <?php } ?>
                                    
                                    <tr>
                                        <th class="text-center">
                                            <button type="submit" class="btn btn-primary"><i class="fa fa-check" aria-hidden="true"></i> Accept</button>
                                        </th> 
                                        <th class="text-right" colspan="3">Total</th>
                                        <th class="text-left"><?php echo $total_loaded; ?></th>
                                        <th class="text-left"><?php echo $total_unloaded; ?></th>
                                        <th class="text-left"><?php echo $total_net; ?></th> 
                                        <th class="text-center"></th> 
                                    </tr>

                                    <?php }else{ ?>

                                    <tr>
                                        <td colspan="8" class="text-center" style="color:red;">No Record Found.</td>
                                    </tr>
                                   <?php } ?>
                                </tbody>
                            </table>
                          </form>

                            <div class="card-body">
                                <div class="d-flex justify-content-end">
                                   <?php echo $weightData->links() ?>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <!--------- Accept model --------->
                <div class="modal fade text-left modal-success" id="success" tabindex="-1" role="dialog" aria-labelledby="myModalLabel160" aria-hidden="true">
                    <div class="modal-dialog" role="document">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h4 id="myModalLabel160">Accept Weight</h4>
                                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <div class="modal-body">
                                <form action="{{ url('/verify_weight_report/save_new_wight') }}" method="POST">
                                @csrf
                                <div id="show_model1"> </div>
                        </form>
                            </div>
                        </div>
                    </div>
                </div>

                <!--------- Reject model --------->
                <div class="modal fade modal-danger text-left" id="danger" tabindex="-1" role="dialog" aria-labelledby="myModalLabel120" aria-hidden="true">
                    <div class="modal-dialog" role="document">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h4 id="myModalLabel120">Reject Weight</h4>
                                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <div class="modal-body">
                                <form action="{{ url('/verify_weight_report/save_reject_reson') }}" method="POST">
                                  @csrf
                                  <div id="show_model2"> </div>
                              </form>
                            </div>
                        </div>
                    </div>
                </div>

            </div>
            <!-- Bordered table end -->
        </div>
    </section>
@endsection

<script>

    function accept_weight(id){
        $.ajax({
            url: 'verify_weight_report/accept_weight',
            type: 'post',
            data: {
                _token: "{{ csrf_token() }}",
                weight_id: id,
            },
            success: function(response) {
                $('#show_model1').html(response);
                //$("#show1").modal({backdrop: true});
            }
        });
    }

    function rejected_weight(id){
        $.ajax({
            url: 'verify_weight_report/reject_weight',
            type: 'post',
            data: {
                _token: "{{ csrf_token() }}",
                weight_id: id,
            },
            success: function(response) {
                $('#show_model2').html(response);
               // $("#show2").modal({backdrop: true});
            }
        });
    }
</script>

<script type="text/javascript">
	function accepted_validation() {

        if ($('#new_weight').val() == ""){
            alert('Please Enter New Weight');
            $('#new_weight').focus();
            return false;
        } 

        if ($('#accepted_reson').val() == ""){
            alert('Please Enter Accepted Reson');
            $('#accepted_reson').focus();
            return false;
        } 
    }

    function isNumberKey(evt)
    {
        var charCode = (evt.which) ? evt.which : event.keyCode
        if (charCode > 31 && (charCode < 48 || charCode > 57))
            return false;
        return true;
    }

    function rejected_validation() {

        if ($('#rejected_reson').val() == ""){
            alert('Please Enter Rejected Reson');
            $('#rejected_reson').focus();
            return false;
        } 
    }

    function selectall(source) {
        checkboxes = document.getElementsByName('verify_weight[]');
        for(var i=0, n=checkboxes.length;i<n;i++) {
            checkboxes[i].checked = source.checked;
        }
    }

</script>


